#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include <dos.h>
#include "x1.h"
#include "x1_crtc.h"
#include "x1_vram.h"
#include "x1_psg.h"
#include "x1_opm.h"
#include "x1_fdc.h"
#include "x1_tape.h"
#include "joypad.h"
#include "text.h"
#include "msdos.h"
#include "debug.h"

byte FDD_PATH[80]={0};
byte CAS_PATH[80]={0};

byte STR_BUF[16*24];
byte *STR_TBL[32];

/***********************************************************************
	t@CI
***********************************************************************/

short ERR_HD=0;

short find(short mode,short top,short cnt,byte *path,byte *ext,byte *tbl[])
{
	byte tmp[80];
	struct find_t fil;
	short no,flg;

	no=ERR_HD=0;

	// subdir
	if(mode & 2){
		sprintf(tmp,"%s*.*",path);
		flg=(_dos_findfirst(tmp,0x16,&fil)?1:0);
		while(!ERR_HD && no<cnt && !flg){
			if(fil.attrib & 0x10){
				if(top) top--; else {
					sscanf(fil.name,"%s",tmp);
					sprintf(tbl[no++],"\\%s",tmp);
				}
			}
			flg=(_dos_findnext(&fil)?1:0);
		}
	}

	if(no>=cnt){
		if(!flg) return 0;
		sprintf(tmp,"%s%s",path,ext);
		return (_dos_findfirst(tmp,0x16,&fil)?1:0);
	}

	// file
	if((mode & 1) && !ERR_HD && no<cnt){
		sprintf(tmp,"%s%s",path,ext);
		flg=(_dos_findfirst(tmp,0x16,&fil)?1:0);
		while(!ERR_HD && no<cnt && !flg){
			if(!(fil.attrib & 0x10)){
				if(top) top--;
				else sscanf(fil.name,"%s",tbl[no++]);
			}
			flg=(_dos_findnext(&fil)?1:0);
		}
	}

	if(ERR_HD){ no=0; flg=2; }

	while(no<cnt) tbl[no++][0]=0;

	return flg;
}

short name_chk(byte *path,byte *name)
{
	short i,n;

	if(!name[0]) return 2;
	if(name[0]!=0x5c) return 1;

	for(i=0; path[i]; i++);
	path[i-1]=0;

	if(       name[1]=='.' && name[2]==  0){
		path[2]=0x5c; path[3]=0; return 0;
	} else if(name[1]=='.' && name[2]=='.'){
		i=n=0;
		while(path[i]){
			if(kanji_chk(path[i])) i++;
			else if(path[i]==0x5c) n=i;
			i++;
		}
		if(n) path[n]=0;
	} else {
		strcat(path,name);
	}

	for(i=0; path[i]; i++);
	path[i  ]=0x5c;
	path[i+1]=0;

	return 0;
}

short path_chk(byte *path)
{
	byte tmp[80];
	struct find_t fil;
	short flg,ans;

	ERR_HD=ans=0;
	sprintf(tmp,"%s*.*",path);
	flg=(_dos_findfirst(tmp,0x16,&fil)?1:0);
	while(!ERR_HD && !flg){
		if(fil.attrib & 0x10){
			if(fil.name[0]!='.'){ ans=1; break; }
		}
		flg=(_dos_findnext(&fil)?1:0);
	}
	if(ERR_HD) ans=2;

	return ans;
}

//----------------------------------------------------------------------

short drive_select(byte *path)
{
	byte str[32];
	short jx,jy,jsw;
	short x0,y0,drv,bak,i;

	for(i=0; i<26; i++) str[i]='A'+i;
	str[i]=0;

	x0=6; y0=0;
	etext( 0,y0,80,0x07,NULL);
	etext( 0,y0,26,0x07,"DRIVE:");
	etext(x0,y0,26,0x07,str);

	drv=0;
	str[0]='A'+drv; str[1]=0;
	etext(x0+drv,y0,1,0x70,str);
	for(;;){
		jsw=menu_key(&jx,&jy);
		if(jsw) break;
		bak=drv; drv+=jx;
		if(     drv< 0) drv=25;
		else if(drv>25) drv= 0;
		if(drv!=bak){
			str[0]='A'+bak; etext(x0+bak,y0,1,0x07,str);
			str[0]='A'+drv; etext(x0+drv,y0,1,0x70,str);
		}
	}
	if(!(jsw&2)){
		strcpy(path,"A:\\");
		path[0]='A'+drv;
	}
	etext(0,y0,80,0x07,NULL);

	return (jsw&2)?1:0;
}

short file_select(short x0,short y0,byte *path,byte *ext,byte *ans)
{
	struct MENU_BAR tbl[32];
	short top,cnt,next;
	short flg,num,sw,i;

	ans[0]=0;

	for(i=0; i<16; i++) STR_TBL[i]=&STR_BUF[i*16];
	STR_TBL[16]=NULL;

	strcpy(STR_TBL[0],"-- ު --"); strcpy(STR_TBL[1],"hCuI");
	strcpy(STR_TBL[2]," O   "); strcpy(STR_TBL[3],"    ");
	for(i=4; i<16; i++) strcpy(STR_TBL[i],"            ");
	bar_ini_v(x0,y0,STR_TBL,tbl);

	sw=1; num=top=0; cnt=(16-4);
	for(;;){
		if(sw){
			sw=0;
			etext(0,0,80,0x07,path);
			next=find(3,top,cnt,path,ext,&STR_TBL[4]);
		}

		flg=menu_sel(1,tbl,&num);
		if(flg) break;

		if(     num==0){ ans[0]=0; break; }
		else if(num==1){ if(!drive_select(path)){ top=0; sw=1; } }
		else if(num==2){ if(top>=cnt){ top-=cnt; sw=1; } }
		else if(num==3){ if(!next   ){ top+=cnt; sw=1; } }
		else {
			if(       STR_TBL[num][0]==0x5c){
				name_chk(path,STR_TBL[num]); top=0; sw=1;
			} else if(STR_TBL[num][0]!=0x00){
				sprintf(ans,"%s%s",path,STR_TBL[num]); break;
			}
		}
	}
	menu_clr(tbl);

	etext(0,0,80,0x07,Title);

	return flg;
}

/***********************************************************************
	QcC[W̃t@CI
***********************************************************************/

byte IMG_TMP[2048];

byte NAME_TBL[80][16]={0};
short NAME_CNT=0;

short img_name_read(short drv)
{
	struct X1_DIR *dir;
	short lng,sct,flg,i;

	NAME_CNT=0;
	for(i=0; i<80; i++) NAME_TBL[i][0]=0;

	lng=sctor_read(drv,0,14,IMG_TMP);
	if(       lng!= 256) return 1;
	if(IMG_TMP[0]!=0x01) return 1;
	if(IMG_TMP[1]!=0x8f) return 1;

	flg=0;
	for(sct=0; sct<=9 && !flg; sct++){
		sctor_read(drv,1,sct,IMG_TMP);
		dir=(struct X1_DIR *)&IMG_TMP[0];
		for(i=0; i<8; i++){
			if(dir[i].mode==0xff){ flg=1; break; }
			if(dir[i].mode&0x01){
				memcpy(NAME_TBL[NAME_CNT],dir[i].name,13);
				NAME_TBL[NAME_CNT][13]=0;
				NAME_CNT++; if(NAME_CNT>=78){ flg=1; break; }
			}
		}
	}

	return 0;
}

short img_name_get(short top,short cnt,unsigned char *tbl[])
{
	short i;

	for(i=0; i<cnt && top<NAME_CNT; i++){
		strcpy(tbl[i],NAME_TBL[top++]);
	}
	while(i<cnt) tbl[i++][0]=0;

	return (top<NAME_CNT?0:1);
}

short soft_select(short x0,short y0,short *no)
{
	struct MENU_BAR tbl[20];
	short top,cnt,next;
	short ans,num,flg,i;

	(*no)=0;
	if(img_name_read(0)) return 1;

	for(i=0; i<16; i++) STR_TBL[i]=&STR_BUF[i*20];
	STR_TBL[16]=NULL;

	strcpy(STR_TBL[0],"   O     ");
	strcpy(STR_TBL[1],"        ");
	for(i=2; i<16; i++) STR_TBL[i][0]=0;
	cnt=(16-2);
	bar_ini_v(x0,y0,STR_TBL,tbl);

	flg=1; ans=top=num=0;
	for(;;){
		if(flg){ flg=0; next=img_name_get(top,cnt,&STR_TBL[2]); }
		ans=menu_sel(1,tbl,&num);
		if(ans) break;
		if(     num==0){ if(top>=cnt){ top-=cnt; flg=1; } }
		else if(num==1){ if(!next   ){ top+=cnt; flg=1; } }
		else if(STR_TBL[num][0]){ (*no)=top+(num-2); break; }
	}
	menu_clr(tbl);

	return ans;
}

/***********************************************************************
	QcC[Wt@C̃[hX^[g
***********************************************************************/

// ްĥںގQ (e`s)
short fd_boot0(void)
{
	struct X1_DIR *dir;
	word rec,sct,trk,i;
	long sta,adr,siz;

	if(sctor_read(0,0,0,IMG_TMP)!=256) return 1;
	dir=(struct X1_DIR *)&IMG_TMP[0];

	if(  dir->mode==0xff) return 1;
	if(!(dir->mode&0x01)) return 1;

	rec =(long)dir[0].cls_m; rec<<=8;
	rec|=(long)dir[0].cls_l;

	sta=(long)dir[0].sta_adr;
	adr=(long)dir[0].top_adr;
	siz=(long)dir[0].size;

	trk=(rec/16);
	sct=(rec%16);
	while(siz){
		sctor_read(0,trk,sct,IMG_TMP);
		for(i=0; i<256 && siz; i++){
			if(adr&0x8000) MAIN1[adr&0x7fff]=IMG_TMP[i];
			else           MAIN0[adr&0x7fff]=IMG_TMP[i];
			adr++; siz--;
		}
		sct++; if(sct>=16){ sct=0; trk++; }
	}

	reset_x1();
	ROM_SW=0;
	Z80_SetPC(sta);

	return 0;
}

// ިڸ؎Q (e`sQ)
short fd_boot1(short num)
{
	struct X1_DIR *dir;
	long cls,sta,adr,siz;
	short sct,i;
	byte fat[256];

	// FAT
	if(sctor_read(0,0,14,IMG_TMP)!=256) return 1;
	memcpy(fat,IMG_TMP,256);

	// DIR
	sctor_read(0,1,num/8,IMG_TMP);
	dir=(struct X1_DIR *)&IMG_TMP[0];
	dir+=(num%8);

	sta=(long)(dir->sta_adr);
	adr=(long)(dir->top_adr);
	siz=(long)(dir->size);
	cls =(long)(dir->cls_h); cls<<=8;
	cls|=(long)(dir->cls_m); cls<<=8;
	cls|=(long)(dir->cls_l);

	while(siz){
		for(sct=0; sct<16 && siz; sct++){
			sctor_read(0,cls,sct,IMG_TMP);
			for(i=0; i<256 && siz; i++){
				if(adr&0x8000) MAIN1[adr&0x7fff]=IMG_TMP[i];
				else           MAIN0[adr&0x7fff]=IMG_TMP[i];
				adr++; siz--;
			}
		}
		if(!siz) break;
		if(fat[cls]&0x80) break;
		cls=(unsigned long)fat[cls];
	}

	reset_x1();
	ROM_SW=0;
	Z80_SetPc(sta);

	return 0;
}

/***********************************************************************
	ݒ胁j[ iv_Ej
***********************************************************************/

short CNF_exec(short x0,short y0)
{
	static byte *stbl[]={
		"ĊJ","I",NULL
	};
	struct MENU_BAR mtbl[4];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	if(num==1) END_SW=1;

	return 0;
}

//----------------------------------------------------------------------

short CNF_reset(short x0,short y0)
{
	static byte *stbl[8]={
		"IPL ؾ  ","NMI ؾ  ",
		"ް ں","۰  ",NULL
	};
	struct MENU_BAR mtbl[8];
	short flg,num,i;
	byte *nam;

	bar_ini_v(x0,y0,stbl,mtbl);
	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	if(       num==0){
		reset_x1();
		ipl_load();
	} else if(num==1){
		Z80_Cause_Interrupt(0x02);
	} else if(num==2){
		flg=fd_boot0();
	} else if(num==3){
		flg=soft_select(x0,y0,&num);
		if(!flg) fd_boot1(num);
	}

	return flg;
}

//----------------------------------------------------------------------

/*
short CNF_dip_sw(short x0,short y0)
{
	static byte *stbl[]={
		" 5 320K޲ 2D          ",
		" 5 640K޲ 2DD         ",
		" 5   1M޲ 2HD         ",
		" 5   1M޲ 2HD (IBM)   ",
		// " 8   1M޲ 2D256       ",
		// " 8   1M޲ 2D256 (IBM) ",
		// " 8 240K޲ 1S128 (IBM) ",
		// " HD    10M޲             ",
		NULL
	};
	struct MENU_BAR mtbl[16];
	short flg,num,i;

	bar_ini_v(x0,y0,stbl,mtbl);

	i=(DIP_SW>>1)&7; if(i<0 || i>3) i=0;
	mtbl[i].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	DIP_SW=0x01|(i<<1);

	return 0;
}
*/

//----------------------------------------------------------------------

short CNF_media(short x0,short y0)
{
	static byte *stbl[]={
		"FDD-0(\*.2D )","FDD-1(\*.2D )",
		"FDD-0(\*.D88)","FDD-1(\*.D88)",
		"CAS  (\*.TAP)",NULL
	};
	struct MENU_BAR mtbl[8];
	short flg,num;
	byte fname[80];

	bar_ini_v(x0,y0,stbl,mtbl);
	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	if(       num==0){
		flg=file_select(x0,y0,FDD_PATH,"*.2D",fname);
		if(!flg) x1_set_fd(0,1,fname);
	} else if(num==1){
		flg=file_select(x0,y0,FDD_PATH,"*.2D",fname);
		if(!flg) x1_set_fd(1,1,fname);
	} else if(num==2){
		flg=file_select(x0,y0,FDD_PATH,"*.D88",fname);
		if(!flg) x1_set_fd(0,2,fname);
	} else if(num==3){
		flg=file_select(x0,y0,FDD_PATH,"*.D88",fname);
		if(!flg) x1_set_fd(1,2,fname);
	} else if(num==4){
		flg=file_select(x0,y0,CAS_PATH,"*.TAP",fname);
		if(!flg){ cmt_eject(); cmt_set(0,fname); }
	}

	etext(0,22,6,0x70,"FDD-0 "); etext(6,22,75,0x70,x1_get_fname(0));
	etext(0,23,6,0x70,"FDD-1 "); etext(6,23,75,0x70,x1_get_fname(1));
	etext(0,24,6,0x70,"TAPE  "); etext(6,24,75,0x70,get_cas_name());

	return 0;
}

//----------------------------------------------------------------------

short CNF_hi_low(short x0,short y0)
{
	static byte *stbl[]={
		"𑜓xj^",
		"𑜓xj^(1׽=1ײ)",
		"𑜓xj^(1׽=2ײ)",
		NULL
	};
	struct MENU_BAR mtbl[4];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	if(ROM_TYPE==1) mtbl[1].c=1;
	else            mtbl[0].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	switch(num){
		case 0: DIP_SW&=~1; CRT_MODE=0; break;
		case 1: DIP_SW|= 1; CRT_MODE=0; break;
		case 2: DIP_SW|= 1; CRT_MODE=1; break;
	}

	return 0;
}

//----------------------------------------------------------------------

short CNF_ipl_rom(short x0,short y0)
{
	static byte *stbl[]={ "Turbo","","Ȃ",NULL };
	struct MENU_BAR mtbl[4];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	if(     ROM_TYPE==2) mtbl[0].c=1;
	else if(ROM_TYPE==1) mtbl[1].c=1;
	else                 mtbl[2].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	switch(num){
		case 0: ROM_TYPE=2; break;
		case 1: ROM_TYPE=1; break;
		case 2: ROM_TYPE=0; break;
	}
	ipl_load();

	return CNF_hi_low(x0,y0);
}

//----------------------------------------------------------------------

short CNF_scrn_l(short x0,short y0)
{
	static byte *stbl[]={
		" 40x25 (320x200) 𑜓x "," 80x25 (640x200) 𑜓x ",
		" 40x12 (320x192) 𑜓x "," 80x12 (640x192) 𑜓x ",
		" 40x20 (-------) 𑜓x "," 80x20 (-------) 𑜓x ",
		" 40x10 (-------) 𑜓x "," 80x10 (-------) 𑜓x ",NULL
	};
	struct MENU_BAR mtbl[16];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	num=0;
	if(TXT_XL==40 || TXT_XL==80){
		if(     TXT_YL==25) num=0;
		else if(TXT_YL==12) num=2;
		else if(TXT_YL==20) num=4;
		else if(TXT_YL==10) num=6;
		if(TXT_XL==80) num++;
	}
	mtbl[num].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	switch(num){
		case  0: scrn_set(&L200_40x25); break;
		case  1: scrn_set(&L200_80x25); break;
		case  2: scrn_set(&L200_40x12); break;
		case  3: scrn_set(&L200_80x12); break;
		case  4: scrn_set(&L000_40x20); break;
		case  5: scrn_set(&L000_80x20); break;
		case  6: scrn_set(&L000_40x10); break;
		case  7: scrn_set(&L000_80x10); break;
	}
	DIP_SW|=0x01;

	return 0;
}

short CNF_scrn_h(short x0,short y0)
{
	static byte *stbl[]={
		" 40x25 (320x200) 𑜓x "," 80x25 (640x200) 𑜓x ",
		" 40x12 (320x192) 𑜓x "," 80x12 (640x192) 𑜓x ",
		" 40x25 (320x400) 𑜓x "," 80x25 (640x400) 𑜓x ",
		" 40x12 (320x384) 𑜓x "," 80x12 (640x384) 𑜓x ",
		" 40x20 (-------) 𑜓x "," 80x20 (-------) 𑜓x ",NULL
	};
	struct MENU_BAR mtbl[16];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	num=0;
	if(TXT_XL==40 || TXT_XL==80){
		if(       TXT_YL==20){
			num=8;
		} else if(CRT_V400&1){
			if(     TXT_YL==12) num=6;
			else if(TXT_YL==25) num=4;
		} else {
			if(     TXT_YL==12) num=2;
			else if(TXT_YL==25) num=0;
		}
		if(TXT_XL==80) num++;
	}
	mtbl[num].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	switch(num){
		case 0: scrn_set(&H200_40x25); break;
		case 1: scrn_set(&H200_80x25); break;
		case 2: scrn_set(&H200_40x12); break;
		case 3: scrn_set(&H200_80x12); break;
		case 4: scrn_set(&H400_40x25); break;
		case 5: scrn_set(&H400_80x25); break;
		case 6: scrn_set(&H400_40x12); break;
		case 7: scrn_set(&H400_80x12); break;
		case 8: scrn_set(&H000_40x20); break;
		case 9: scrn_set(&H000_80x20); break;
	}
	DIP_SW&=~0x01;

	return 0;
}

short CNF_screen(short x0,short y0)
{
	static byte *stbl[]={ "𑜓x[h","𑜓x[h",NULL };
	struct MENU_BAR mtbl[4];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	mtbl[!CRT_V400?0:1].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);

	if(!flg){
		if(!num) flg=CNF_scrn_l(x0,y0);
		else     flg=CNF_scrn_h(x0,y0);
	}

	return flg;
}

//----------------------------------------------------------------------

short CNF_wait(short x0,short y0)
{
	static byte *stbl[]={
		"Ė","V-SYNC","TIMER",NULL
	};
	struct MENU_BAR mtbl[16];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	mtbl[WAITFLG%3].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	WAITFLG=num;
	crtc_updt();

	return 0;
}

//----------------------------------------------------------------------

short CNF_skip(short x0,short y0)
{
	static byte *stbl[]={
		"O","P","Q","S",
		"W","16","32",NULL
	};
	struct MENU_BAR mtbl[16];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	if(     DRAW_SKIP== 0) mtbl[0].c=1;
	else if(DRAW_SKIP== 1) mtbl[1].c=1;
	else if(DRAW_SKIP== 2) mtbl[2].c=1;
	else if(DRAW_SKIP== 4) mtbl[3].c=1;
	else if(DRAW_SKIP== 8) mtbl[4].c=1;
	else if(DRAW_SKIP==16) mtbl[5].c=1;
	else if(DRAW_SKIP==32) mtbl[6].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	if(     num==0) DRAW_SKIP= 0;
	else if(num==1) DRAW_SKIP= 1;
	else if(num==2) DRAW_SKIP= 2;
	else if(num==3) DRAW_SKIP= 4;
	else if(num==4) DRAW_SKIP= 8;
	else if(num==5) DRAW_SKIP=16;
	else if(num==6) DRAW_SKIP=32;

	return 0;
}

//----------------------------------------------------------------------

short CNF_keybord(short x0,short y0)
{
	static byte *stbl[]={ "m[}","","gȂ",NULL };
	struct MENU_BAR mtbl[4];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	if(     KEY_MODE==0) mtbl[0].c=1;
	else if(KEY_MODE==1) mtbl[1].c=1;
	else                 mtbl[2].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	switch(num){
		case 0: KEY_MODE=0; break;
		case 1: KEY_MODE=1; break;
		case 2: KEY_MODE=2; break;
	}

	return 0;
}

//----------------------------------------------------------------------

short CNF_sfc_pad(short x0,short y0)
{
	static byte *stbl[]={ "ڲ԰1","ڲ԰2","ڲ԰3","ڲ԰4","ڲ԰5",NULL };
	struct MENU_BAR mtbl[8];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	if(JOY_NO>4) JOY_NO=0;
	mtbl[JOY_NO].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);

	if(!flg) JOY_NO=num;

	return flg;
}

short CNF_psx_pad(short x0,short y0)
{
	static byte *stbl[]={ "ڲ԰1","ڲ԰2","ڲ԰3","ڲ԰4",NULL };
	struct MENU_BAR mtbl[8];
	short flg,num;

	bar_ini_v(x0,y0,stbl,mtbl);
	if(JOY_NO>3) JOY_NO=0;
	mtbl[JOY_NO].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);

	if(!flg) JOY_NO=num;

	return flg;
}

short CNF_joypad(short x0,short y0)
{
	static byte *stbl[]={
		"","JOY","̧","ڽ","SB݊","26K/86",NULL
	};
	struct MENU_BAR mtbl[8];
	short flg,num;

	if(!PC98FLG) stbl[5]=NULL;

	// JOY_TYPE 0=,1=SFC,2=PSX,3=SB,4=98,9=JOY-KEY

	bar_ini_v(x0,y0,stbl,mtbl);
	if(     JOY_TYPE==0) mtbl[0].c=1;
	else if(JOY_TYPE==9) mtbl[1].c=1;
	else if(JOY_TYPE==1) mtbl[2].c=1;
	else if(JOY_TYPE==2) mtbl[3].c=1;
	else if(JOY_TYPE==3) mtbl[4].c=1;
	else if(JOY_TYPE==4) mtbl[5].c=1;

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	pad_end();
	switch(num){
		case 0: JOY_TYPE=0; JOY_NO=0; break;
		case 1: JOY_TYPE=9; JOY_NO=0; break;
		case 2: JOY_TYPE=1; CNF_sfc_pad(x0,y0); break;
		case 3: JOY_TYPE=2; CNF_psx_pad(x0,y0); break;
		case 4: JOY_TYPE=3; JOY_NO=0; break;
		case 5: JOY_TYPE=4; JOY_NO=0; break;
	}
	pad_ini();

	return 0;
}

//----------------------------------------------------------------------

short CNF_etc(short x0,short y0)
{
	static byte *stbl[8]={  "alo Z[u",NULL,NULL,NULL,NULL };
	static byte *log_sw[]={ "OPM۸:~","OPM۸:L^" };
	static byte *txt_sw[]={ "98÷:~","98÷:쓮" };
	struct MENU_BAR mtbl[8];
	short flg,num;

	if(!opm_trace_chk()) stbl[1]=log_sw[0];
	else                 stbl[1]=log_sw[1];
	if(      PC98FLG==1) stbl[2]=txt_sw[0];
	else if( PC98FLG==2) stbl[2]=txt_sw[1];
	else                 stbl[2]=NULL;
	stbl[3]=NULL;
	bar_ini_v(x0,y0,stbl,mtbl);

	flg=menu_sel(1,mtbl,&num);
	menu_clr(mtbl);
	if(flg) return flg;

	if(       num==0){
		bmp_save();
	} else if(num==1){
		if(!opm_trace_chk()) opm_trace_start();
		else                 opm_trace_end();
	} else if(num==2){
		PC98FLG=(PC98FLG==1?2:1);
	}

	return 0;
}

/***********************************************************************
	ݒ胁j[
***********************************************************************/

/*
void Test(void)
{
	short i,x,y;
	struct GPTN ptn;

	i=0;
	for(y=0; y<16; y++){
		for(x=0; x<16; x++){
			ptn.b=ANK_FNT[i]; ptn.r=ANK_FNT[i];
			ptn.g=ANK_FNT[i]; ptn.m=DMY_FF; i++;
			put88(2+x,8+y,&ptn);
		}
	}
}
*/

short cnf_menu(void)
{
	static byte *stbl[]={
		"Эڰ","N/ؾ","FDD/CAS","IPL-ROM","",
		"","ʍXV","ް","JoyPad","̑",NULL
	};
	struct MENU_BAR mtbl[16];
	short flg,num,x,y,fff;
	static short _sw=0;
	// byte str[80];

	if(!_sw){
		_sw=1;
		strcpy(FDD_PATH,PRG_PATH);
		strcpy(CAS_PATH,PRG_PATH);
	}

	END_SW=0;
	x1_psg_pause();
	x1_opm_pause();
	cmt_disp_sw(0);
	scrn_update(1);

	// Test();

	//-------

	fff=1;
	bar_ini_h(1,1,stbl,mtbl);

	while(!END_SW){
		if(fff){
			fff=0;
			etext(0, 0,80,0x07,Title);
			etext(0, 1,80,0x70,NULL);
			if(PC98FLG){
				etext(0,19,80,0x07,"G~[g̓L[");
			} else {
				etext(0,18,80,0x07,"G~[g̓L[");
				etext(0,19,80,0x06,"(Alt:GRPH) (/S: ۯ) ");
			}
			etext(0,20,80,0x07,"    ̧ݸ|6:REW      |7:PLAY/STOP |8:FF      |9:CMT On/Off|10:ƭ");
			etext(0,21,80,0x07,"+̧ݸ|6:REW(o)|7:EJECT     |8:FF(o)|9:CMT On/Off|10:ޯ");
			etext(0,22,6,0x70,"FDD-0 "); etext(6,22,75,0x70,x1_get_fname(0));
			etext(0,23,6,0x70,"FDD-1 "); etext(6,23,75,0x70,x1_get_fname(1));
			etext(0,24,6,0x70,"TAPE  "); etext(6,24,75,0x70,get_cas_name());
		}

		while(menu_sel(0,mtbl,&num));
		while(!END_SW){
			x=mtbl[num].x; y=mtbl[num].y+1;
			switch(num){
				case 0: flg=CNF_exec(x,y); break;
				case 1: flg=CNF_reset(x,y); break;
				case 2: flg=CNF_media(x,y); break;
				case 3: flg=CNF_ipl_rom(x,y); break;
				case 4: flg=CNF_screen(x,y); fff=1; break;
				case 5: flg=CNF_wait(x,y); break;
				case 6: flg=CNF_skip(x,y); break;
				case 7: flg=CNF_keybord(x,y); break;
				case 8: flg=CNF_joypad(x,y); break;
				case 9: flg=CNF_etc(80-13,y); break;
			}
			if(flg!=2 && flg!=3) break;

			mtbl[num].c=0;
			if(     flg==2){ num--; if(num<0) num=9; }
			else if(flg==3){ num++; if(num>9) num=0; }
			mtbl[num].c=1;
			menu_dsp(mtbl);
		}
		if((num==0 || num==1) && flg==0) break;
	}

	//-------

	x1_psg_continue();
	x1_opm_continue();
	scrn_update(0);
	cmt_disp_sw((cmt_tape_stat()&2)?1:0);
	cmt_counter(1);

	return flg;
}

