#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dos.h>
#include <io.h>
#include "x1.h"
#include "x1_fdc.h"

/***********************************************************************
	cWWt@C̓o
***********************************************************************/

// wb_[ (688 Bytes)
struct D88_HEADER {
	unsigned char fd_name[17]; // fBXN̖O(ASCIIZ)
	unsigned char res[9];  // U[u (00H)
	unsigned char protect; // CgveNg (00H:Ȃ,10H:)
	unsigned char fd_type; // fBXN̎   (00H:2D,10H:2DD,20H:2HD)
	unsigned long fd_size; // t@C̃TCY (ecP)
} D88H;

// ZN^[ (16 Bytes)
struct D88_SECTOR {
	struct {
		unsigned char c;
		unsigned char h;
		unsigned char r;
		unsigned char n;
	} id;
	short count; // ZN^[
	unsigned char mfm_flg; // L^x     (00H:{x,40H:Px)
	unsigned char del_flg; // DELETED DATA (00H:m[},10H:DELETED DATA)
	unsigned char stat;    // Xe[^X   (00H:m[}Gh,̑G[[DISK BIOSԂXe[^X])
	unsigned char res[5];  // U[u     (00H)
	short size;            // 㑱̃f[^̃TCY
} D88S;

// ޶ ?
#define SBUF_LNG 2048

byte  BUF_D88[4][SBUF_LNG]={0};
dword ADR_D88[4]={0};
byte  FLG_D88[4]={0};

struct D88_SECTOR SCT_D88[4]={0};

byte FDD_D88[4][80]={0};

/***********************************************************************
	ZN^ƃf[^
***********************************************************************/

// ߂
short d88_sct_flush(word drv)
{
	FILE *fp;
	word lng;

	if(!FDD_D88[drv][0]) return 0;
	if(!ADR_D88[drv]) return 0;
	if(!FLG_D88[drv]) return 0;

	lng=SCT_D88[drv].size;
	if(!lng) return 0;
	if(lng>SBUF_LNG) lng=SBUF_LNG;

	fp=fopen(FDD_D88[drv],"r+b");
	if(fp!=NULL){
		fseek(fp,ADR_D88[drv],SEEK_SET);
		fwrite(BUF_D88[drv],1,lng,fp);
		fclose(fp);
	}

	return 0;
}

// ǂݍ
short d88_sct_read(word drv,dword adr)
{
	FILE *fp;
	short lng;

	if(!FDD_D88[drv][0]) return 1;

	d88_sct_flush(drv);

	fp=fopen(FDD_D88[drv],"rb");
	if(fp==NULL) return 1;

	fseek(fp,adr,SEEK_SET);

	lng=(word)(sizeof(struct D88_SECTOR));
	fread(&SCT_D88[drv],1,lng,fp); // ZN^

	FLG_D88[drv]=0;
	ADR_D88[drv]=(adr+(dword)lng); // f[^ւ̃ItZbg

	lng=SCT_D88[drv].size; if(lng>SBUF_LNG) lng=SBUF_LNG;
	fread( BUF_D88[drv],1,lng,fp); // f[^

	fclose(fp);

	return 0;
}

/***********************************************************************
	cWWZN^ǂݍݑҔ
***********************************************************************/

// *** d88_sct_set()  ^Cvw ***

// #define SCT_SET_TYPE 0 // e[u
#define SCT_SET_TYPE 1 // e[u
// #define SCT_SET_TYPE 2 // e[u傫

short d88_sct_ini(word drv);
short d88_sct_set(word drv,word id_c,word id_h,word id_r);

short d88_sct_read(word drv,dword adr);
short d88_sct_flush(word drv);

//----------------------------------------------------------------------
#if SCT_SET_TYPE==0
//----------------------------------------------------------------------

short d88_sct_ini(word drv)
{
	if(!FDD_D88[drv][0]) return 1;
	return 0;
}

short d88_sct_set(word drv,word id_c,word id_h,word id_r)
{
	FILE *fp;
	dword adr;
	word trk,cnt;
	word lng,err;

	err=0;
	if(!FDD_D88[drv][0]) return 1;

	// Ҕ𒆂̃ZN^ƓH
	if(SCT_D88[drv].size){
		if(SCT_D88[drv].id.c==id_c){
			if(SCT_D88[drv].id.h==id_h){
				if(SCT_D88[drv].id.r==id_r) return 0;
			}
		}
	}

	fp=fopen(FDD_D88[drv],"rb");
	if(fp==NULL) return 1;

	// adr <- gbN̐擪ItZbgǂݍ
	trk=(id_c*2)+id_h;
	adr=(dword)(sizeof(struct D88_HEADER)+(trk*4));
	fseek(fp,adr,SEEK_SET); fread(&adr,1,4,fp);
	if(ferror(fp)){ fclose(fp); return 1; }

	// w̃gbN݂͑邩H
	if(!adr){ fclose(fp); return 1; }

	// w̃ZN^T
	cnt=0; lng=(word)(sizeof(struct D88_SECTOR));
	for(;;){
		fseek(fp,adr,SEEK_SET); fread(&D88S,1,lng,fp);
		if(ferror(fp)){ err=1; break; }

		if((word)(D88S.id.r)==id_r) break;

		cnt++; if(cnt>=D88S.count){ err=1; break; }
		adr+=(dword)(lng); adr+=(dword)D88S.size;
	}
	fclose(fp);

	// ZN^̓ǂݍ
	if(!err) err=d88_sct_read(drv,adr);

	return err;
}

//----------------------------------------------------------------------
#elif SCT_SET_TYPE==1
//----------------------------------------------------------------------

word  TRK_NUM[4]={0};
dword TRK_TBL[4][256]={0};

short d88_sct_ini(word drv)
{
	TRK_NUM[drv]=255;

	if(!FDD_D88[drv][0]) return 1;
	return 0;
}

short d88_trk_set(word drv,word trk)
{
	FILE *fp;
	dword adr;
	word cnt,lng,err;

	err=0;
	if(!FDD_D88[drv][0]) return 1;

	// Ҕ𒆂̃gbNƓH
	if(TRK_NUM[drv]==trk) return 0;

	if(trk>163) return 1;

	fp=fopen(FDD_D88[drv],"rb");
	if(fp==NULL) return 1;

	// adr <- gbN̐擪ItZbgǂݍ
	adr=(dword)(sizeof(struct D88_HEADER)+(trk*4));
	fseek(fp,adr,SEEK_SET); fread(&adr,1,4,fp);
	if(ferror(fp)){ fclose(fp); return 1; }

	// w̃gbN݂͑邩H
	if(!adr){ fclose(fp); return 1; }

	for(cnt=0; cnt<256; cnt++) TRK_TBL[drv][cnt]=0l;

	// eZN^̐擪ItZbge[uɑҔ
	cnt=0; lng=(word)(sizeof(struct D88_SECTOR));
	for(;;){
		fseek(fp,adr,SEEK_SET); fread(&D88S,1,lng,fp);
		if(ferror(fp)){ err=1; break; }

		TRK_TBL[drv][D88S.id.r]=adr;

		cnt++; if(cnt>=D88S.count) break;
		adr+=(dword)(lng); adr+=(dword)D88S.size;
	}

	fclose(fp);

	if(!err){
		TRK_NUM[drv]=trk;
	} else {
		TRK_NUM[drv]=0xff;
		for(cnt=0; cnt<256; cnt++) TRK_TBL[drv][cnt]=0l;
	}

	return err;
}

short d88_sct_set(word drv,word id_c,word id_h,word id_r)
{
	dword adr;

	if(!FDD_D88[drv][0]) return 1;

	// Ҕ𒆂̃ZN^ƓH
	if(SCT_D88[drv].size){
		if(SCT_D88[drv].id.c==id_c){
			if(SCT_D88[drv].id.h==id_h){
				if(SCT_D88[drv].id.r==id_r) return 0;
			}
		}
	}

	if(d88_trk_set(drv,(id_c*2)+id_h)) return 1;

	adr=TRK_TBL[drv][id_r];
	if(!adr) return 1;

	return d88_sct_read(drv,adr);
}

//----------------------------------------------------------------------
#elif SCT_SET_TYPE==2
//----------------------------------------------------------------------

dword DSK_TBL[4][164][256]={0}; // <- 656K Byte !!
dword trk_tbl[164];

short d88_sct_ini(word drv)
{
	FILE *fp;
	dword adr;
	word trk,cnt;
	word lng,err;

	err=0;
	if(!FDD_D88[drv][0]) return 1;

	// cWW̃ZN^zue[uɑҔ

	for(trk=0; trk<164; trk++){
		for(cnt=0; cnt<256; cnt++) DSK_TBL[drv][trk][cnt]=0l;
	}

	fp=fopen(FDD_D88[drv],"rb");
	if(fp==NULL) return 1;

	fseek(fp,(dword)sizeof(struct D88_HEADER),SEEK_SET);
	for(trk=0; trk<164; trk++){
		fread(&trk_tbl[trk],1,4,fp);
		if(ferror(fp)){ err=1; break; }
	}
	if(err){ fclose(fp); return 1; }

	lng=(word)(sizeof(struct D88_SECTOR));
	for(trk=0; trk<164 && !err; trk++){
		cnt=0; adr=trk_tbl[trk];
		if(adr){
			for(;;){
				fseek(fp,adr,SEEK_SET); fread(&D88S,1,lng,fp);
				if(ferror(fp)){ err=1; break; }
				DSK_TBL[drv][trk][D88S.id.r]=adr;
				cnt++; if(cnt>=D88S.count) break;
				adr+=(dword)(lng); adr+=(dword)D88S.size;
			}
		}
	}

	fclose(fp);

	return err;
}

short d88_sct_set(word drv,word id_c,word id_h,word id_r)
{
	dword adr;
	word  trk;

	if(!FDD_D88[drv][0]) return 1;

	// Ҕ𒆂̃ZN^ƓH
	if(SCT_D88[drv].size){
		if(SCT_D88[drv].id.c==id_c){
			if(SCT_D88[drv].id.h==id_h){
				if(SCT_D88[drv].id.r==id_r) return 0;
			}
		}
	}

	// w̃gbN݂͑邩H
	trk=(id_c*2)+id_h;
	if(trk>163) return 1;

	// w̃ZN^݂͑邩H
	adr=DSK_TBL[drv][trk][id_r];
	if(!adr) return 1;

	// ZN^̓ǂݍ
	return d88_sct_read(drv,adr);
}

//----------------------------------------------------------------------
#endif
//----------------------------------------------------------------------

/***********************************************************************
	cWWt@C̓o
***********************************************************************/

unsigned char *fdd_name_d88(short drv)
{
	return FDD_D88[drv];
}

short fdd_eject_d88(struct FDC_REGS *fdc,short drv)
{
	if(drv<0 || drv>3) return 1;
	d88_sct_flush(drv);

	memset(&SCT_D88[drv],0,sizeof(struct D88_SECTOR));
	ADR_D88[drv]=0l;
	FLG_D88[drv]=0;
	FDD_D88[drv][0]=0;

	fdc->img[drv]=0;
	fdc->wpt[drv]=0;

	return 0;
}

short fdd_set_d88(struct FDC_REGS *fdc,short drv,byte *fname,long top_adr)
{
	unsigned atr;
	FILE *fp;

	if(drv<0 || drv>3) return 1;
	fdd_eject_d88(fdc,drv);

	fdc->img[drv]=2;
	strcpy(FDD_D88[drv],fname);

	if(d88_sct_ini(drv)){
		fdd_eject_d88(fdc,drv); return 1;
	}

	// CgEveNg `FbN
	fdc->wpt[drv]=0;
	_dos_getfileattr(FDD_D88[drv],&atr);
	if(atr&_A_RDONLY) fdc->wpt[drv]=1;
	else {
		fp=fopen(FDD_D88[drv],"rb");
		if(fp!=NULL){
			fread(&D88H,1,sizeof(struct D88_HEADER),fp);
			if(!ferror(fp)) fdc->wpt[drv]=(D88H.protect?1:0);
			fclose(fp);
		}
	}

	return 0;
}

//**********************************************************************

short fdd_crc_d88(struct FDC_REGS *fdc)
{
	struct D88_SECTOR *d88s;

	d88s=&SCT_D88[fdc->drv];
/*
	(fdc->crc_dat[0])=(fdc->crc_dat[1])=0;
	(fdc->crc_dat[2])=(fdc->crc_dat[3])=0;
	(fdc->crc_dat[4])=(fdc->crc_dat[5])=0;
*/

	if(d88_sct_set(fdc->drv,fdc->c,fdc->h,fdc->r)) return 1;

	fdc->crc_dat[0]=(d88s->id.c); fdc->crc_dat[1]=(d88s->id.h);
	fdc->crc_dat[2]=(d88s->id.r); fdc->crc_dat[3]=(d88s->id.n);
	fdc->crc_dat[4]=0; // CRC(Lo)
	fdc->crc_dat[5]=0; // CRC(Hi)
	fdc->crc_off=0;

	return 0;
}

byte fdd_stat_d88(struct FDC_REGS *fdc)
{
	struct D88_SECTOR *d88s;
	byte type,cmnd,ans,dmy;
	word trk;

	// NOT READY
	if(fdc->img[fdc->drv]!=2) return 0x80;

	d88s=&SCT_D88[fdc->drv];
	if(d88_sct_set(fdc->drv,fdc->c,fdc->h,fdc->r)){
		memset(d88s,0,sizeof(struct D88_SECTOR));
	}

	ans=0;
	type=(fdc->type);
	cmnd=(fdc->cmnd)>>4;
	trk =(word)(fdc->c)*2;
	trk+=(word)(fdc->h);

	if(type==1 || type==4 || cmnd==0x0a || cmnd==0x0b || cmnd==0x0f){
		// WRITE PROTECT
		if(fdc->wpt[fdc->drv]) ans|=0x40;
	}
	if(type==1 || type==4){
		// HEAD ENGAGED (X1   1)
		ans|=0x20;
	} else if(cmnd==0x8 || cmnd==0x9 || cmnd==0xc || cmnd==0xe){
		// RECODE TYPE
		if(d88s->del_flg) ans|=0x20;
	} else {
		// WRITE FAULT
		if(fdc->wpt[fdc->drv]) ans|=0x20;
	}
	if(type==1 || type==2 || cmnd==0x0c){
		// SEEK ERROR / RECORD NOT FOUND
		if(trk>163) ans|=0x10;
		else if(!d88s->size) ans|=0x10;
	}

	if(type==1 || type==2 || cmnd==0x0c){
		// CRC ERROR
		if(!(ans&0xf0)){
			if(d88s->stat==0xa0) ans|=0x08;
		}
	}

	if(       type==1 || type==4){
		// TRACK00
		if((fdc->c)==0) ans|=0x04;
/* x1_fdc.c   
		// INDEX
		if(d88s->id.r==1) ans|=0x02;
*/
	} else if(type==2 || type==3){
		if(!(ans&0xf0)){
			if((fdc->sct_off)<(d88s->size)){
				ans|=0x03; // DATA REQUEST / BUSY
			}
		}
	}

	return ans;
}

//**********************************************************************

short inc_off_d88(struct FDC_REGS *fdc)
{
	struct D88_SECTOR *d88s;
	byte cmnd,dmy;

	if(d88_sct_set(fdc->drv,fdc->c,fdc->h,fdc->r)) return 1;
	d88s=&SCT_D88[fdc->drv];

	(fdc->sct_off)++;
	if((fdc->sct_off)<(d88s->size)) return 0;

	cmnd=(fdc->cmnd)>>4;
	if(cmnd==0x09 || cmnd==0x0b){
		if(!d88_sct_set(fdc->drv,fdc->c,fdc->h,(fdc->r)+1)){
			(fdc->r)++; (fdc->sct_off)=0; return 0;
		}
		d88_sct_set(fdc->drv,fdc->c,fdc->h,fdc->r);
	}
	(fdc->sct_off)=(d88s->size);

	return 1;
}

//**********************************************************************

byte fdd_read_d88(struct FDC_REGS *fdc)
{
	byte stat;

	// if(d88_sct_set(fdc->drv,fdc->c,fdc->h,fdc->r)) return 0;

	stat=fdd_stat_d88(fdc);
	if((stat&0xf0)!=0) return 0;
	if((stat&0x03)!=3) return 0;

	if((fdc->sct_off)>SBUF_LNG) return 0;
	if((fdc->sct_off)>=SCT_D88[fdc->drv].size) return 0;

	return BUF_D88[fdc->drv][fdc->sct_off];
}

void fdd_write_d88(struct FDC_REGS *fdc,byte data)
{
	byte stat;

	// if(d88_sct_set(fdc->drv,fdc->c,fdc->h,fdc->r)) return 0;

	stat=fdd_stat_d88(fdc);
	if((stat&0xf0)!=0) return;
	if((stat&0x03)!=3) return;

	if((fdc->sct_off)>SBUF_LNG) return;
	if((fdc->sct_off)>=SCT_D88[fdc->drv].size) return;

	FLG_D88[fdc->drv]=1;

	BUF_D88[fdc->drv][fdc->sct_off]=data;
}

//**********************************************************************

// CONFIG.C  gp
short fdd_sct_d88(short drv,short trk,short sct,byte *buff)
{
	word lng;

	// sct  0   +1
	if(d88_sct_set(drv,trk/2,trk&1,sct+1)) return 0;

	lng=SCT_D88[drv].size;
	memcpy(buff,BUF_D88[drv],lng);

	return lng;
}

