#include <dos.h>
#include <io.h>
#include <i86.h>
#include "x1.h"
#include "joypad.h"

byte joy_key_98(void); // <- pc98.c
byte joy_key_at(void); // <- pcat.c

short JOY_TYPE=0;
short JOY_NO=0;

short JOY_SKP=64;
short JOY_BIT=0xff;

short JOY_PORT=0x201;

static unsigned short LPT_DATA=0x140;
static unsigned short LPT_STAT=0x141;

short lpt_ini(void)
{
	unsigned char *chk;
	short flg;

	flg=0;

	if(!PC98FLG){
		LPT_DATA=0x378;
		LPT_STAT=0x379;
		flg=0;
	} else {
		chk=(unsigned char *)0x458l;
		if((*chk)&0x02){
			// tZg
			outp(0x149,0x10); // tZgɐ؂ւ
			LPT_DATA=0x140;
			LPT_STAT=0x141;
			flg=1;
		} else {
			// ȈՃZg
			LPT_DATA=0x040;
			LPT_STAT=0x042;
			flg=2;
		}
	}

	outp(LPT_DATA,0); // pbh̓dIt

	return flg;
}

void lpt_end(void)
{
	unsigned char *chk;

	outp(LPT_DATA,0); // pbh̓dIt

	if(LPT_DATA==0x140){
		chk=(unsigned char *)0x458l;
		if((*chk)&0x02){
			if((*chk)&0x04) outp(0x149,0x10); // tZg
			else            outp(0x149,0x00); // ȈՃZg
		}
	}
}

/***********************************************************************
	X[t@~
***********************************************************************/

static unsigned short BIT1P=0x40;
static unsigned short BIT2P=0x20;
static unsigned short BIT3P=0x10;
static unsigned short BIT4P=0x08;
static unsigned short BIT5P=0x80;

short pad_ini_sfc(void)
{
	switch(lpt_ini()){
		case 0: BIT1P=0x40; BIT2P=0x20; BIT3P=0x10; BIT4P=0x08; BIT5P=0x80; break;
		case 1: BIT1P=0x40; BIT2P=0x20; BIT3P=0x10; BIT4P=0x08; BIT5P=0x80; break;
		case 2: BIT1P=BIT2P=BIT3P=BIT4P=0; BIT5P=0x04; break;
	}
	return 0;
}

void pad_end_sfc(void)
{
	lpt_end();
}

static void sfc_wait(short cnt)
{
	while(cnt--) outp(0x5f,0);
}

byte pad_scan_sfc(void)
{
	byte tbl[16];
	word sfc,i;
	byte msk,joy;
	#define PWR 0xf8
	#define CLK 0x01
	#define LAT 0x02

	outp(LPT_DATA,PWR|CLK);     // pbh̓dI
	sfc_wait(3);

	outp(LPT_DATA,PWR|CLK|LAT); // f[^Eb`
	sfc_wait(3);

	// {^Ԃ̓ǂݍ (͌)
	for(i=0; i<12; i++){
		outp(LPT_DATA,PWR|CLK);    sfc_wait(3);
		tbl[i]=inp(LPT_STAT)^0x78; sfc_wait(3);
		outp(LPT_DATA,PWR    );    sfc_wait(3);
	}

	outp(LPT_DATA,0); // pbh̓dIt
	sfc_wait(3);

	// Ԃ̔
	if(     JOY_NO==0) msk=BIT1P;
	else if(JOY_NO==1) msk=BIT2P;
	else if(JOY_NO==2) msk=BIT3P;
	else if(JOY_NO==3) msk=BIT4P;
	else if(JOY_NO==4) msk=BIT5P;
	sfc=0xffff;
	for(i=0; i<12; i++){ sfc<<=1; if(tbl[i] & msk) sfc|=1; }

	// SFC->X1
	joy=0xff;
	if(sfc==0xffff) sfc=0;
	if(sfc&0x001) joy^=0x20; // R
	if(sfc&0x002) joy^=0x40; // L
	if(sfc&0x004) joy^=0x20; // X
	if(sfc&0x008) joy^=0x20; // A
	if(sfc&0x010) joy^=0x08; // RIGHT
	if(sfc&0x020) joy^=0x04; // LEFT
	if(sfc&0x040) joy^=0x02; // DOWN
	if(sfc&0x080) joy^=0x01; // UP
	if(sfc&0x100) joy^=0x40; // STA
	if(sfc&0x200) joy^=0x20; // SEL
	if(sfc&0x400) joy^=0x40; // Y
	if(sfc&0x800) joy^=0x40; // B

	return joy;
}

/***********************************************************************
	vXe
***********************************************************************/

static unsigned char PSX_BIT=0xf7;

short pad_ini_psx(void)
{
	PSX_BIT=0xf7;
	return (lpt_ini()==2?1:0);
}

void pad_end_psx(void)
{
	lpt_end();
}

void psx_clk(short i)
{
	if(i) PSX_BIT|= 0x04;
	else  PSX_BIT&=~0x04;
	outp(LPT_DATA,PSX_BIT);
}

void psx_sel(short i)
{
	if(i) PSX_BIT|= 0x02;
	else  PSX_BIT&=~0x02;
	outp(LPT_DATA,PSX_BIT);
}

void psx_cmd(short i)
{
	if(i) PSX_BIT|= 0x01;
	else  PSX_BIT&=~0x01;
	outp(LPT_DATA,PSX_BIT);
}

short psx_dat(short id)
{
	unsigned char bit;

	bit=(id==1?0x40:0x10);

	return (inp(LPT_STAT)&bit)?1:0;
}

short psx_ack(short id)
{
	unsigned char bit;

	bit=(id==1?0x20:0x08);

	return (inp(LPT_STAT)&bit)?1:0;
}

void psx_slow(void)
{
	short i;
	for(i=0; i<3; i++) outp(LPT_DATA,PSX_BIT);
}

unsigned char psx_byte(unsigned char byte,short wait,short id)
{
	unsigned char data;
	unsigned char bit;
	short i;

	data=0;
	for(bit=1; bit; bit<<=1){
		psx_slow();
		psx_cmd(byte&bit);
		psx_clk(0);
		psx_slow();
		psx_clk(1);
		if(psx_dat(id)) data|=bit;
	}

	// Wait for ACK;
	if(wait){
		for(i=0; i<300 &&  psx_ack(id); i++);
		for(i=0; i<300 && !psx_ack(id); i++);
	}

	return data;
}

byte pad_scan_psx(void)
{
	byte work[16];
	byte joy,dmy;

	psx_sel(1); psx_clk(1); psx_cmd(1);
	psx_slow(); psx_slow(); psx_slow();
	psx_slow(); psx_slow(); psx_slow();
	psx_sel(0);
	psx_slow(); psx_slow();

	work[0]=psx_byte(0x01,1,JOY_NO);
	work[1]=psx_byte(0x42,1,JOY_NO);
	if(       work[1]==0x41){
		work[2]=psx_byte(0x00,1,JOY_NO);
		work[3]=psx_byte(0x00,1,JOY_NO);
		work[4]=psx_byte(0x00,0,JOY_NO);
	} else if(work[1]==0x53){
		work[2]=psx_byte(0x00,1,JOY_NO);
		work[3]=psx_byte(0x00,1,JOY_NO);
		work[4]=psx_byte(0x00,1,JOY_NO);
		work[5]=psx_byte(0x00,1,JOY_NO);
		work[6]=psx_byte(0x00,1,JOY_NO);
		work[7]=psx_byte(0x00,1,JOY_NO);
		work[8]=psx_byte(0x00,0,JOY_NO);
	} else if(work[1]==0x73 || work[1]==0x23){
		work[2]=psx_byte(0x00,1,JOY_NO);
		work[3]=psx_byte(0x00,1,JOY_NO);
		work[4]=psx_byte(0x00,1,JOY_NO);
		work[5]=psx_byte(0x00,1,JOY_NO);
		work[6]=psx_byte(0x00,1,JOY_NO);
		work[7]=psx_byte(0x00,1,JOY_NO);
		work[8]=psx_byte(0x00,1,JOY_NO);
		work[9]=psx_byte(0x00,0,JOY_NO);
	}
	psx_slow(); psx_slow();
	psx_sel(1); psx_cmd(1); psx_clk(1);
	psx_slow();

	/*******/

	joy=0xff;
	if(!(work[3]&0x10)) joy^=0x01; // UP
	if(!(work[3]&0x20)) joy^=0x08; // RIGHT
	if(!(work[3]&0x40)) joy^=0x02; // DOWN
	if(!(work[3]&0x80)) joy^=0x04; // LEFT
	if(!(work[3]&0x08)) joy^=0x40; // STA
	if(!(work[3]&0x01)) joy^=0x20; // SEL
	if(!(work[4]&0x40)) joy^=0x20; // ~
	if(!(work[4]&0x20)) joy^=0x40; // 
	if(!(work[4]&0x01)) joy^=0x40; // L2
	switch(work[1]){
		case 0x73: // analog red   mode
		case 0x53: // analog green mode
			if(!(work[4]&0x04)) joy^=0x20; // 
			if(!(work[4]&0x08)) joy^=0x40; // 
			if(!(work[4]&0x10)) joy^=0x20; // R1
			if(!(work[4]&0x02)) joy^=0x40; // L1
			if(!(work[4]&0x80)) joy^=0x20; // R2
		break;
		default:
			if(!(work[4]&0x80)) joy^=0x20; // 
			if(!(work[4]&0x10)) joy^=0x40; // 
			if(!(work[4]&0x08)) joy^=0x20; // R1
			if(!(work[4]&0x04)) joy^=0x40; // L1
			if(!(work[4]&0x02)) joy^=0x20; // R2
		break;
	}

	return joy;
}

/**********************************************************************
	TEhuX^[݊
**********************************************************************/

short pad_ini_sb(void)
{
	return 0;
}

void pad_end_sb(void)
{
}

/*
byte pad_scan_sb(void)
{
	static word ll=0;
	static word l0=0;
	static word l1=0;
	union REGS r;
	word x,y;
	byte btn,ans;

	// ޮè ()
	r.h.ah=0x84; r.w.dx=0; int386(0x15,&r,&r);
	btn=r.h.al;

	// ޮè (X,Y)
	r.h.ah=0x84; r.w.dx=1; int386(0x15,&r,&r);
	x=r.w.ax; y=r.w.bx; // Pad-A(X=ax,Y=bx) Pad-B(X=cx,Y=dx)

	ans=0xff;
	if(btn & 0x10) ans^=0x40;
	if(btn & 0x20) ans^=0x20;
	if(x!=0xffff && x){
		if(ll<x){ ll=x; l0=(ll/3); l1=(ll-l0); }
		if(     x>l1) ans^=0x08;
		else if(x<l0) ans^=0x04;
	}
	if(y!=0xffff && y){
		if(ll<y){ ll=y; l0=(ll/3); l1=(ll-l0); }
		if(     y>l1) ans^=0x02;
		else if(y<l0) ans^=0x01;
	}

	return ans;
}
*/

byte pad_scan_sb(void)
{
	static word skip=0;
	static byte ans=0xff;
	static byte dmy;
//static word ll=0xffff;
//static word l0=0x5555;
//static word l1=0xaaaa;
	static word ll=0;
	static word l0=0;
	static word l1=0;
	word x,y,i;
	byte bak,bit;
	byte flg,dmy2;

	if(skip){ skip--; return ans; }
	skip=JOY_SKP;

	_disable();
	outp(JOY_PORT,0);
	x=y=0; flg=0; bak=(byte)inp(JOY_PORT);
	for(i=0xffff; i; i--){
		bit=(byte)inp(JOY_PORT);
		if(bit!=bak) flg=1;
		if(bit & 1) x++;
		if(bit & 2) y++;
	}
	_enable();

	if(!flg) return 0xff;

	ans=0xff;
	if(bit&0x10) ans^=0x40;
	if(bit&0x20) ans^=0x20;
	if(x!=0xffff){
		if(ll<x){ ll=x; l0=(ll/3); l1=(ll-l0); }
		if(     x>l1) ans^=0x08;
		else if(x<l0) ans^=0x04;
	}
	if(y!=0xffff){
		if(ll<y){ ll=y; l0=(ll/3); l1=(ll-l0); }
		if(     y>l1) ans^=0x02;
		else if(y<l0) ans^=0x01;
	}

	return ans;
}

/**********************************************************************
	ob|XWOP|QUj
**********************************************************************/

short pad_ini_98(void)
{
	return 0;
}

void pad_end_98(void)
{
}

byte pad_scan_98(void)
{
	short reg,val;
	short joy,i;

	if(!SOUND_SW) return 0xff;

/*
 PC9801-26/K
   b7 b6 b5 b4 b3 b2 b1 b0
    1  1 a `    
 X1
   b7 b6 b5 b4 b3 b2 b1 b0
    1 a `  1    
*/

	reg=7;
	outp(0x188,reg); for(i=0; i<32; i++) outp(0x5f,0);
	val=inp(0x18a);  for(i=0; i<32; i++) outp(0x5f,0);
	val=(val&0x3f)|0x80;
	outp(0x18a,val); for(i=0; i<32; i++) outp(0x5f,0);

	reg=7; val=0x8f;
	outp(0x188,reg); for(i=0; i<32; i++) outp(0x5f,0);
	outp(0x18a,val); for(i=0; i<32; i++) outp(0x5f,0);

	reg=14;
	outp(0x188,reg); for(i=0; i<32; i++) outp(0x5f,0);
	val=inp(0x18a);  for(i=0; i<32; i++) outp(0x5f,0);

	joy =(val&15)|0x90;
	joy|=(val<<1)&0x60;

	return (byte)joy;
}

/**********************************************************************
	OQƂ֐
**********************************************************************/

short pad_ini(void)
{
	short err;

	JOY_BIT=0xff;

	err=0;
	if(     JOY_TYPE==1) err=pad_ini_sfc();
	else if(JOY_TYPE==2) err=pad_ini_psx();
	else if(JOY_TYPE==3) err=pad_ini_sb();
	else if(JOY_TYPE==4) err=pad_ini_98();
	else if(JOY_TYPE!=9) err=1;
	if(err) JOY_TYPE=0;

	return err;
}

void pad_end(void)
{
	if(     JOY_TYPE==1) pad_end_sfc();
	else if(JOY_TYPE==2) pad_end_psx();
	else if(JOY_TYPE==3) pad_end_sb();
	else if(JOY_TYPE==4) pad_end_98();
}

void pad_scan(void)
{
	if(     JOY_TYPE==1) JOY_BIT=pad_scan_sfc();
	else if(JOY_TYPE==2) JOY_BIT=pad_scan_psx();
	else if(JOY_TYPE==3) JOY_BIT=pad_scan_sb();
	else if(JOY_TYPE!=4 && JOY_TYPE!=9) JOY_BIT=0xff;
}

byte pad_get(void)
{
	if(       JOY_TYPE==4){
		JOY_BIT=pad_scan_98();
	} else if(JOY_TYPE==9){
		if(PC98FLG) JOY_BIT=joy_key_98();
		else        JOY_BIT=joy_key_at();
	}
	return (byte)JOY_BIT;
}

