
#include "common.h"
#include "z80.h"

#define BOSS 0

struct GPTN { byte *b,*r,*g,*m; };

struct X1_DIR {
	byte mode;
	byte name[16];
	byte pass;
	word size;
	word top_adr;
	word sta_adr;
	byte time[5];
	byte cls_h;
	byte cls_l;
	byte cls_m;
};

struct SND_PRM {
	unsigned char int_num;
	unsigned char ver_num;

	unsigned char psg_reg;
	unsigned char psg_dat;
	unsigned char psg_sta;
	unsigned char psg_flg;

	unsigned char opm_reg;
	unsigned char opm_dat;
	unsigned char opm_sta;
	unsigned char opm_flg;

	unsigned char dmy[6];
};

//----------------------------------------------------------------------

extern unsigned char Title[80];
extern unsigned char PRG_PATH[80];

extern byte *RAM0;
extern byte *RAM1;
extern byte *KNJ_FNT;

extern short PC98FLG;
extern short KEY_MODE;
extern short SOUND_SW;

extern short END_SW;
extern short MENU_SW;
extern short BMP_NUM;

extern short DIP_SW;
extern short ROM_TYPE;

extern short ROM_SW;
extern short IO_MODE;

extern short SYNC_MODE;
extern short V_DISP;
extern short V_SYNC;

extern short VSYNC_FLG;
extern short H_CNT;
extern short V_CNT;

extern short JOY_TYPE;
extern short JOY_NO;

extern word OPMDRV_IRQ;
extern short OPM_MODE;
extern short PSG_MODE;

extern short DRAW_SKIP;

extern word WAITFLG;
extern word VSYNC_98; // XŴu|rxmb
extern word VSYNC_AT; // `ŝu|rxmb
extern word VSYNC_TM; // ^C}[EFCgp

extern short SHIFT_KEY;

extern struct SND_PRM far *SndPrm;

//----------------------------------------------------------------------

extern byte PCG_B[256][8];
extern byte PCG_R[256][8];
extern byte PCG_G[256][8];

extern byte ANK_FNT[256][8];

extern byte X2TBL0[256];
extern byte X2TBL1[256];
extern word X2TBLW[256];

extern byte DMY_00[256]; // 0x00256oCgKvȂƂQƂ
extern byte DMY_FF[256]; // 0xff256oCgKvȂƂQƂ

//----------------------------------------------------------------------

extern byte MAIN0[0x8000]; // 0000-7fff Ҳݥذ
extern byte MAIN1[0x8000]; // 8000-ffff Ҳݥذ

extern byte BIOS[0x8000];     // 0000-7fff IPL & BIOS ROM
extern byte BANK[16][0x8000]; // 0000-7fff RAM 16ݸ

extern byte TXT_ATR[0x800];
extern byte TXT_ANK[0x800];
extern byte TXT_KAN[0x800];

extern byte GRP_B00[0x4000],GRP_R00[0x4000],GRP_G00[0x4000],GRP_M00[0x4000];
extern byte GRP_B01[0x4000],GRP_R01[0x4000],GRP_G01[0x4000],GRP_M01[0x4000];
extern byte TXT_B00[0x4000],TXT_R00[0x4000],TXT_G00[0x4000],TXT_M00[0x4000];
extern byte TXT_B01[0x4000],TXT_R01[0x4000],TXT_G01[0x4000],TXT_M01[0x4000];
extern byte CRT_B00[0x4000],CRT_R00[0x4000],CRT_G00[0x4000],CRT_M00[0x4000];
extern byte CRT_B01[0x4000],CRT_R01[0x4000],CRT_G01[0x4000],CRT_M01[0x4000];
extern byte CRT_B02[0x4000],CRT_R02[0x4000],CRT_G02[0x4000],CRT_M02[0x4000];
extern byte CRT_B03[0x4000],CRT_R03[0x4000],CRT_G03[0x4000],CRT_M03[0x4000];
extern byte CRT_F00[0x4000],CRT_F01[0x4000];

/***********************************************************************
***********************************************************************/

void Z80_MEM_W(word A,byte V);
byte Z80_MEM_R(word A);

void Z80_IO_W(word Port,byte Value);
byte Z80_IO_R(word Port);

// --- Z80.C ---
void Z80_Reset(void);
void Z80_SetPc(word adr);
short Z80_Iff2(void);
void Z80_Intrpt(word vct);
short Z80_Exec(void);

//----------------------------------------------------------------------

short ipl_load(void);
short reset_x1(void);

/***********************************************************************
	nol@g[X
***********************************************************************/

short opm_trace_chk(void);
void opm_trace_init(void);

void opm_trace_start(void);
void opm_trace_end(void);
void opm_trace_cnt(void);
void opm_trace_reg(byte reg,byte val);
void psg_trace_reg(byte reg,byte val);

/**********************************************************************
	fobOp iobXWpj
**********************************************************************/

short str_dsp(short x,short y,short col,unsigned char *buf);
short int_dsp(short x,short y,short col,int dat);
short hex_dsp(short x,short y,short col,int dat);
short byt_dsp(short x,short y,short col,int dat);

