#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <dos.h>
#include "x1.h"
#include "x1_dma.h"

/***********************************************************************
	DMA
***********************************************************************/

byte DMA_ENBL=0;
byte DMA_REDY=1; // <- FDC  Lo  
byte INT_ENBL=0;

byte DMA_MODE=0;
byte DMA_CMND=0;

byte MASK_BYT=0;
byte MACH_BYT=0;

byte MACH_FLG=0;
byte ENDB_FLG=0;

byte INT_FLG=0;
byte INT_PLS=0;
byte INT_VCT=0;

byte RR_MSK=0x00;
byte RR=0x38;

union _PAIR {
	byte b[2];
	word w;
};

union _PAIR ADR_A;
union _PAIR ADR_B;
union _PAIR BYT_L;

union _PAIR CNT_A;
union _PAIR CNT_B;
union _PAIR BYT_N;

byte WR[8]={ 0,0,0,0,0,0,0,0 };

word WR_CNT=0;
word WR_OFF=0;
byte *WR_TBL[16];

word RR_CNT=0;
word RR_OFF=0;
byte *RR_TBL[16];

//**********************************************************************

#define DMA_TEST 0

#if DMA_TEST
void dma_log(void)
{
	word *src_adr,*des_adr;
	byte  src_flg, des_flg;

	if(WR[0]&0x04){ // A->B
		src_flg=WR[1]; src_adr=&CNT_A.w;
		des_flg=WR[2]; des_adr=&CNT_B.w;
	} else { // B->A
		src_flg=WR[2]; src_adr=&CNT_B.w;
		des_flg=WR[1]; des_adr=&CNT_A.w;
	}

	if(     DMA_MODE==0) printf("(޲  Ӱ)");
	else if(DMA_MODE==1) printf("(- Ӱ)");
	else if(DMA_MODE==2) printf("(ݿ޸ Ӱ)");

	if(WR[0]&0x04){
		if(WR[1]&0x08) printf("I/O:%04x ",ADR_A.w);
		else           printf("MEM:%04x ",ADR_A.w);
		if(!(src_flg&0x20)){
			if(src_flg&0x10) printf("(+) ");
			else             printf("(-) ");
		}
		printf(" -> ");
		if(WR[2]&0x08) printf("I/O:%04x ",ADR_B.w);
		else           printf("MEM:%04x ",ADR_B.w);
		if(!(des_flg&0x20)){
			if(des_flg&0x10) printf("(+) ");
			else             printf("(-) ");
		}
	} else {
		if(WR[2]&0x08) printf("I/O:%04x ",ADR_B.w);
		else           printf("MEM:%04x ",ADR_B.w);
		if(!(src_flg&0x20)){
			if(src_flg&0x10) printf("(+) ");
			else             printf("(-) ");
		}

		printf(" -> ");

		if(WR[1]&0x08) printf("I/O:%04x ",ADR_A.w);
		else           printf("MEM:%04x ",ADR_A.w);
		if(!(des_flg&0x20)){
			if(des_flg&0x10) printf("(+) ");
			else             printf("(-) ");
		}
	}
	printf("SIZE:%08d(%04xH)\n",BYT_L.w+1,BYT_L.w+1);
}

#endif

//**********************************************************************

short init_dma(void)
{
	DMA_ENBL=0; DMA_REDY=1;
	DMA_MODE=0; DMA_CMND=0;
	INT_ENBL=0;

	INT_FLG=INT_PLS=INT_VCT=0;
	MACH_BYT=MASK_BYT=0;
	MACH_FLG=ENDB_FLG=0;

	ADR_A.w=CNT_A.w=0;
	ADR_B.w=CNT_B.w=0;
	BYT_L.w=BYT_N.w=0;

	WR[0]=WR[1]=WR[2]=WR[3]=0;
	WR[4]=WR[5]=WR[6]=WR[7]=0;
	WR_CNT=WR_OFF=0;

	RR_MSK=0; RR=0x38;
	RR_CNT=RR_OFF=0;

	return 0;
}

void x1_dma(void)
{
	word *src_adr,*des_adr;
	byte  src_flg, des_flg;
	byte v0,v1,val,dmy;
	word vct;

	if(DMA_CMND<1) return;
	if(DMA_CMND>3) return;
	if(!DMA_ENBL ) return;

	if(ENDB_FLG) return;
	if((DMA_CMND & 2) && MACH_FLG) return;

	if(DMA_MODE!=1){ // èƭӰ ޲  ķ
		if(WR[5]&0x08){ // REDY  Hi(1)  ճ
			if(!DMA_REDY) return;
		} else {        // REDY  Lo(0)  ճ
			if( DMA_REDY) return;
		}
	}

#if DMA_TEST
	if(BYT_N.w==0) dma_log();
#endif

	if(WR[0]&0x04){ // A->B
		src_flg=WR[1]; src_adr=&CNT_A.w;
		des_flg=WR[2]; des_adr=&CNT_B.w;
	} else { // B->A
		src_flg=WR[2]; src_adr=&CNT_B.w;
		des_flg=WR[1]; des_adr=&CNT_A.w;
	}

	do{
		if(ENDB_FLG) break;
		if((DMA_CMND & 2) && MACH_FLG) break;

		if(src_flg & 8) val=Z80_In(   *src_adr);
		else            val=Z80_RDMEM(*src_adr);
		if(DMA_CMND & 1){ // ݽ̧
			if(des_flg & 8) Z80_Out(  *des_adr,val);
			else            Z80_WRMEM(*des_adr,val);
		}
		if(DMA_CMND & 2){ // ϯ
			v0=(val     |MASK_BYT);
			v1=(MACH_BYT|MASK_BYT);
			if(v0==v1) MACH_FLG=1;
		}

		if(!(src_flg&0x20)){ if(src_flg&0x10) (*src_adr)++; else (*src_adr)--; }
		if(!(des_flg&0x20)){ if(des_flg&0x10) (*des_adr)++; else (*des_adr)--; }

		BYT_N.w++; if(BYT_N.w>=BYT_L.w+1) ENDB_FLG=1;
	}while(DMA_MODE);

	if(INT_ENBL && Z80_IFF2()){
		vct=0;
		if(     (INT_FLG & 0x01) && MACH_FLG) vct=1;
		else if((INT_FLG & 0x02) && ENDB_FLG) vct=2;
		if(vct){
			if(INT_FLG & 0x20) vct=(INT_VCT&0xf9)|(vct<<1);
			else vct=INT_VCT;
			Z80_Cause_Interrupt(vct);
		}
	}
}

void x1_dma_w(word P,byte V)
{
	static byte dmy1,dmy2;
	byte wr;

	DMA_ENBL=0;

	if(!WR_CNT){
		wr=6; WR_CNT=WR_OFF=0;
		if(!(V & 0x80)){
			if(     (V&3)!=0) wr=0;
			else if((V&7)==4) wr=1;
			else if((V&7)==0) wr=2;
		} else {
			if(     (V&3)==0             ) wr=3;
			else if((V&3)==1 && (V>>5)!=7) wr=4;
			else if((V&7)==2 && !(V&0x40)) wr=5;
			else if((V&3)==3             ) wr=6;
		}
		WR[wr]=V;
		switch(wr){
			case 0:
				DMA_CMND=(V&3);
				if(V&0x08) WR_TBL[WR_CNT++]=&ADR_A.b[0];
				if(V&0x10) WR_TBL[WR_CNT++]=&ADR_A.b[1];
				if(V&0x20) WR_TBL[WR_CNT++]=&BYT_L.b[0];
				if(V&0x40) WR_TBL[WR_CNT++]=&BYT_L.b[1];
			break;
			case 1: if(V&0x40) WR_TBL[WR_CNT++]=&dmy1; break;
			case 2: if(V&0x40) WR_TBL[WR_CNT++]=&dmy2; break;
			case 3:
				if(V&0x08) WR_TBL[WR_CNT++]=&MASK_BYT;
				if(V&0x10) WR_TBL[WR_CNT++]=&MACH_BYT;
				INT_ENBL=(V&0x20)?1:0;
				DMA_ENBL=(V&0x40)?1:0;
			break;
			case 4:
				DMA_MODE=(WR[4]>>5)&3;
				if(V&0x04) WR_TBL[WR_CNT++]=&ADR_B.b[0];
				if(V&0x08) WR_TBL[WR_CNT++]=&ADR_B.b[1];
				if(V&0x10){
					WR_TBL[WR_CNT++]=&INT_FLG;
					WR_TBL[WR_CNT++]=&INT_PLS;
					WR_TBL[WR_CNT++]=&INT_VCT;
					WR_CNT-=2;
				}
			break;
			case 6:
				switch(V){
					case 0x83: DMA_ENBL=0; break; // DMAި
					case 0x87: DMA_ENBL=1; break; // DMAȰ
					case 0x8b: MACH_FLG=ENDB_FLG=0; break; // إƼײޥð޲

					case 0xa7: // Ƽĥذޥݽ
						RR_CNT=RR_OFF=0;
						if(RR_MSK & 0x01) RR_TBL[RR_CNT++]=&RR;
						if(RR_MSK & 0x02) RR_TBL[RR_CNT++]=&BYT_N.b[0];
						if(RR_MSK & 0x04) RR_TBL[RR_CNT++]=&BYT_N.b[1];
						if(RR_MSK & 0x08) RR_TBL[RR_CNT++]=&CNT_A.b[0];
						if(RR_MSK & 0x10) RR_TBL[RR_CNT++]=&CNT_A.b[1];
						if(RR_MSK & 0x20) RR_TBL[RR_CNT++]=&CNT_B.b[0];
						if(RR_MSK & 0x40) RR_TBL[RR_CNT++]=&CNT_B.b[1];
					break;
					case 0xab: INT_ENBL=1; break; // ĥȰ
					case 0xaf: INT_ENBL=0; break; // ĥި

					case 0xb3: DMA_REDY=(WR[5]&0x08)?1:0; break; // ި
					case 0xbb: WR_TBL[WR_CNT++]=&RR_MSK; break; // ذޥϽ̫۰
					case 0xbf: RR_MSK=1; break; // ذޥð޲

					case 0xc3: init_dma(); break; // ؾ
					case 0xc7: break; // ؾĥ߰Aݸ
					case 0xcb: break; // ؾĥ߰Bݸ
					case 0xcf: // ۰
						DMA_MODE=(WR[4]>>5)&3;
						CNT_A.w=ADR_A.w;
						CNT_B.w=ADR_B.w;
						ENDB_FLG=MACH_FLG=0;
						BYT_N.w=0; DMA_ENBL=0;
					break;
					case 0xd3: // èƭ
						ENDB_FLG=MACH_FLG=0;
						BYT_N.w=0; DMA_ENBL=1;
					break;
				}
			break;
		}
	} else {
		*WR_TBL[WR_OFF]=V;
		if(WR_TBL[WR_OFF]==&INT_FLG){
			if(V&0x08) WR_CNT++;
			if(V&0x10) WR_CNT++;
		}
		WR_OFF++; WR_CNT--;
	}
}

byte x1_dma_r(word P)
{
	RR=0xcc;

	if( DMA_ENBL) RR|=0x01;
	if(DMA_MODE!=1){
		if(WR[5]&0x08){ if(!DMA_REDY) RR|=0x02; }
		else{           if( DMA_REDY) RR|=0x02; }
	}

	if(!MACH_FLG) RR|=0x10;
	if(!ENDB_FLG) RR|=0x20;

	if(RR_OFF>=RR_CNT) RR_OFF=0;

	return (byte)(*RR_TBL[RR_OFF++]);
}

