#include <stdio.h>
#include <string.h>
#include <io.h>
#include <i86.h>
#include <dos.h>
#include <fcntl.h>
#include "x1.h"
#include "x1_opm.h"

/***********************************************************************
	nol
***********************************************************************/

byte OPM_REG_NUM=0;
byte OPM_REG_TBL[256]={0};

static union REGS Regs;

// extern word OPMDRV_IRQ; // <- 0x6a

//----------------------------------------------------------------------

void x1_opm_ini(void)
{
	OPM_REG_NUM=0;
	memset(OPM_REG_TBL,0,256);

	if(       OPM_MODE==1){
		Regs.w.ax=1; int386(OPMDRV_IRQ,&Regs,&Regs);
	} else if(OPM_MODE==2){
		(SndPrm->opm_flg)=2;
		Regs.w.dx=1; int386(SndPrm->int_num,&Regs,&Regs);
	}
}

void x1_opm_end(void)
{
	if(       OPM_MODE==1){
		Regs.w.ax=4; int386(OPMDRV_IRQ,&Regs,&Regs);
	} else if(OPM_MODE==2){
		(SndPrm->opm_flg)=3;
		Regs.w.dx=1; int386(SndPrm->int_num,&Regs,&Regs);
		(SndPrm->opm_flg)=2;
		Regs.w.dx=1; int386(SndPrm->int_num,&Regs,&Regs);
	}

	OPM_REG_NUM=0;
	memset(OPM_REG_TBL,0,256);
}

//......................................................................

void x1_opm_pause(void)
{
	if(       OPM_MODE==1){
		Regs.w.ax=4; int386(OPMDRV_IRQ,&Regs,&Regs);
	} else if(OPM_MODE==2){
		(SndPrm->opm_flg)=3;
		Regs.w.dx=1; int386(SndPrm->int_num,&Regs,&Regs);
	}
}

void x1_opm_continue(void)
{
	if(       OPM_MODE==1){
		Regs.w.ax=3; int386(OPMDRV_IRQ,&Regs,&Regs);
	} else if(OPM_MODE==2){
		(SndPrm->opm_flg)=4;
		Regs.w.dx=1; int386(SndPrm->int_num,&Regs,&Regs);
	}
}

//......................................................................

short FmBusy=0;

void x1_opm_reg(byte value)
{
	OPM_REG_NUM=value;
}

void x1_opm_datw(byte value)
{
	FmBusy=1;

	if(       OPM_MODE==1){
		Regs.w.ax=2;
		Regs.h.ch=OPM_REG_NUM;
		Regs.h.cl=value;
		int386(OPMDRV_IRQ,&Regs,&Regs);
	} else if(OPM_MODE==2){
		(SndPrm->opm_flg)=0;
		(SndPrm->opm_reg)=OPM_REG_NUM;
		(SndPrm->opm_dat)=value;
		Regs.w.dx=1; int386(SndPrm->int_num,&Regs,&Regs);
	}

	opm_trace_reg(OPM_REG_NUM,value);
}

/*
  elXe[^X
	|d7  |d6|d5|d4|d3|d2|d1 |d0 |
	|BUSY|  |  |  |  |  |IST|IST|

	d7:BUSY rW[Ԃ̂ƂP
	d1:IST  ^C}[aI[o[t[łP
	d0:IST  ^C}[`I[o[t[łP

	R}h݌AUSNbN̊Ԃ̓rW[ԂɂȂ
*/

byte x1_opm_datr(void)
{
	byte ans,dmy;

	ans=0xff;
	if(OPM_MODE) ans=(FmBusy?0xfc:0x7f);
	FmBusy=0;

	return ans;
}

