#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <fcntl.h>
#include "x1.h"
#include "x1_tape.h"
#include "msdos.h"

/***********************************************************************
	SUB CPU
***********************************************************************/

short SCPU_IBF=0; // OȂSUB-CPUɃf[^𑗂Ă悢
short SCPU_OBF=1; // OȂSUB-CPŨf[^L

short SUB_MODE=0x00;
short SUB_CMD_CNT=0;
short SUB_DAT_CNT=0;

byte SUB_Dx[16][8]={0};
byte SUB_Ex[16][8]={0};

//               e3 e4 e5 e6 e7 e8 e9 ea eb ec ed ee ef
byte CMD_TBL[]={  0, 1, 0, 0, 1, 0, 1, 0, 0, 3, 0, 3, 0 };
byte DAT_TBL[]={  3, 0, 0, 2, 0, 1, 0, 1, 1, 0, 3, 0, 3 };

//**********************************************************************

short INT_SW=0;

short init_scpu(void)
{
	short i,n;

	INT_SW=0;

	SCPU_IBF=0;
	SCPU_OBF=1;

	SUB_MODE=0;
	SUB_CMD_CNT=0;
	SUB_DAT_CNT=0;
	for(n=0; n<16; n++){
		for(i=0; i<8; i++){
			SUB_Dx[n][i]=0;
			SUB_Ex[n][i]=0;
		}
	}

	return 0;
}

//**********************************************************************

// L[{[h̉`FbN  L[{[h荞
short x1_sub_int(void)
{
	exkey_x1();

	if(KEY_MODE!=0) return 1;

	if( SCPU_IBF) return 1;
	if(!SCPU_OBF) return 1;

	if(INT_SW){
		if(Z80_IFF2()){
			INT_SW=0; x1_sub_w(0x1900,0xe6);
			Z80_Cause_Interrupt(SUB_Ex[4][0]);
		}
	} else if(SUB_Ex[4][0]){
		if(key_int_chk()){
			INT_SW=1; key_int_clr();
		}
	}

	return 0;
}

//**********************************************************************

byte bcd_sub(short dat)
{
	byte ans;

	dat%=100;
	ans =(dat/10);
	ans<<=4;
	ans|=(dat%10);

	return ans;
}

void x1_sub_w(word P,byte V)
{
	static byte *tbl;
	static short off=0;
	struct dosdate_t dtbl;
	struct dostime_t ttbl;

	if(SCPU_IBF) return;

	if(!SUB_CMD_CNT){
		off=0;
		SUB_MODE=V;
		SUB_CMD_CNT=0;
		SUB_DAT_CNT=0;
		if(     V>=0xd0 && V<=0xd7){ SUB_CMD_CNT=6; SUB_DAT_CNT=0; }
		else if(V>=0xd8 && V<=0xdf){ SUB_CMD_CNT=0; SUB_DAT_CNT=6; }
		else if(V>=0xe3 && V<=0xef){
			SUB_CMD_CNT=CMD_TBL[V-0xe3];
			SUB_DAT_CNT=DAT_TBL[V-0xe3];
		}
		if(V<0xe0) tbl=SUB_Dx[V-0xd0];
		else       tbl=SUB_Ex[V-0xe0];

		if(       SUB_MODE==0xe3){
			if(KEY_MODE!=2) game_key_x1(&tbl[0]);
			else{ tbl[0]=0; tbl[1]=0; tbl[2]=0; }
		} else if(SUB_MODE==0xe6){
			if(KEY_MODE!=2) key_get_x1(&tbl[0],&tbl[1]);
			else{ tbl[0]=0xff; tbl[1]=0x00; }
		} else if(SUB_MODE==0xed){
			_dos_getdate(&dtbl);
			tbl[0]=bcd_sub(dtbl.year);
			tbl[1] =(dtbl.month%13)<<4;
			tbl[1]|=(dtbl.dayofweek%7);
			tbl[2]=bcd_sub(dtbl.day);
		} else if(SUB_MODE==0xef){
			_dos_gettime(&ttbl);
			tbl[0]=bcd_sub(ttbl.hour);
			tbl[1]=bcd_sub(ttbl.minute);
			tbl[2]=bcd_sub(ttbl.second);
		}
	} else {
		tbl[off++]=V; SUB_CMD_CNT--;
		if(SUB_MODE==0xe9) cmt_ctrl(V);
	}

	SCPU_OBF=(SUB_DAT_CNT?0:1);
	SCPU_IBF=(SUB_DAT_CNT?1:0);
}

byte x1_sub_r(word P)
{
	short ans;

	if(SCPU_OBF) return 0xff;

	ans=0xff;
	switch(SUB_MODE){
		case 0xd8: ans=SUB_Dx[0][6-SUB_DAT_CNT]; break;
		case 0xd9: ans=SUB_Dx[1][6-SUB_DAT_CNT]; break;
		case 0xda: ans=SUB_Dx[2][6-SUB_DAT_CNT]; break;
		case 0xdb: ans=SUB_Dx[3][6-SUB_DAT_CNT]; break;
		case 0xdc: ans=SUB_Dx[4][6-SUB_DAT_CNT]; break;
		case 0xdd: ans=SUB_Dx[5][6-SUB_DAT_CNT]; break;
		case 0xde: ans=SUB_Dx[6][6-SUB_DAT_CNT]; break;
		case 0xdf: ans=SUB_Dx[7][6-SUB_DAT_CNT]; break;

		case 0xe3: ans=SUB_Ex[0x03][3-SUB_DAT_CNT]; break;
		case 0xe6: ans=SUB_Ex[0x06][2-SUB_DAT_CNT]; break;
		case 0xe8: ans=SUB_Ex[0x07][0]; break;
		case 0xea: ans=cmt_cntl_stat(); break;
		case 0xeb: ans=cmt_tape_stat(); break;
		case 0xed: ans=SUB_Ex[0x0d][3-SUB_DAT_CNT]; break;
		case 0xef: ans=SUB_Ex[0x0f][3-SUB_DAT_CNT]; break;
	}

	SUB_DAT_CNT--;
	SCPU_OBF=(SUB_DAT_CNT?0:1);
	SCPU_IBF=(SUB_DAT_CNT?1:0);

	return (byte)(ans&0xff);
}

