#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <fcntl.h>
#include <i86.h>
#include "x1.h"
#include "x1_crtc.h"
#include "x1_pcg.h"
#include "x1_vram.h"
#include "msdos.h"

byte GMASK_FLG[400];
byte GMASK_MSK[400][80];

byte TXT_ATR98[0x20];

short CRT_MODE=0; // 200ײ  ķ 0=1ײݥ 1=2ײ

/***********************************************************************
	
***********************************************************************/

word init_vram(void)
{
	short x,y;
	byte n,atr;

	for(n=0; n<0x20; n++){
		atr=(n<<5)|1;
		if(n&0x08) atr|=0x04;
		if(n&0x10) atr|=0x02;
		TXT_ATR98[n]=atr;
	}

	for(y=0; y<400; y++){
		GMASK_FLG[y]=0;
		for(x=0; x<80; x++) GMASK_MSK[y][x]=0;
	}

	memset(TXT_ATR,0x07,0x0800);
	memset(TXT_ANK,0x20,0x0800);
	memset(TXT_KAN,0x00,0x0800);

	memset(TXT_B00,0x00,0x4000); memset(TXT_R00,0x00,0x4000);
	memset(TXT_G00,0x00,0x4000); memset(TXT_M00,0x00,0x4000);
	memset(TXT_B01,0x00,0x4000); memset(TXT_R01,0x00,0x4000);
	memset(TXT_G01,0x00,0x4000); memset(TXT_M01,0x00,0x4000);

	memset(GRP_B00,0x00,0x4000); memset(GRP_R00,0x00,0x4000);
	memset(GRP_G00,0x00,0x4000); memset(GRP_M00,0x00,0x4000);
	memset(GRP_B01,0x00,0x4000); memset(GRP_R01,0x00,0x4000);
	memset(GRP_G01,0x00,0x4000); memset(GRP_M01,0x00,0x4000);

	memset(CRT_B00,0x00,0x4000); memset(CRT_R00,0x00,0x4000);
	memset(CRT_G00,0x00,0x4000); memset(CRT_M00,0x00,0x4000);
	memset(CRT_B01,0x00,0x4000); memset(CRT_R01,0x00,0x4000);
	memset(CRT_G01,0x00,0x4000); memset(CRT_M01,0x00,0x4000);
	memset(CRT_B02,0x00,0x4000); memset(CRT_R02,0x00,0x4000);
	memset(CRT_G02,0x00,0x4000); memset(CRT_M02,0x00,0x4000);
	memset(CRT_B03,0x00,0x4000); memset(CRT_R03,0x00,0x4000);
	memset(CRT_G03,0x00,0x4000); memset(CRT_M03,0x00,0x4000);
	memset(CRT_F00,0x03,0x4000); memset(CRT_F01,0x03,0x4000);

	return 0;
}

/***********************************************************************
	ʏɃRgp̔\GAmۂ
***********************************************************************/

void gmask_set(short x1,short y1,short x2,short y2)
{
	short x,y;

	y1*=16; y2*=16; y2+=15;
	for(y=y1; y<=y2; y++){
		GMASK_FLG[y]=1;
		for(x=x1; x<=x2; x++) GMASK_MSK[y][x]=1;
	}
}

void gmask_clr(short x1,short y1,short x2,short y2)
{
	short x,y,flg;

	y1*=16; y2*=16; y2+=15;
	for(y=y1; y<=y2; y++){
		for(x=x1; x<=x2; x++) GMASK_MSK[y][x]=0;
		for(x= 0; x< 80; x++){ if(GMASK_MSK[y][x]) break; }
		GMASK_FLG[y]=(x<80?1:0);
	}

	scrn_update(0);
}

/***********************************************************************
	eLXgu|q`l -> zOtBbN
***********************************************************************/

void _flg_sub(byte *flg)
{
	short i;
	i=(FNT_YL>8?8:FNT_YL)<<TXT_MODE;
	while(i--){ (*flg)|=1; flg+=VRAM_STP; }
}

void _clr_sub(byte *src)
{
	short i;
	i=(FNT_YL>8?8:FNT_YL)<<TXT_MODE;
	while(i--){ (*src)=0; src+=VRAM_STP; }
}

void _msk_sub(byte *src,byte *msk)
{
	short i;

	i=(FNT_YL>8?8:FNT_YL)<<TXT_MODE;
	while(i--){
		(*msk)|=(*src);
		msk+=VRAM_STP;
		src+=VRAM_STP;
	}
}

void _cpy_sub(byte *src,byte *d0,byte *d1)
{
	byte i,l;

	l=(FNT_YL>8?8:FNT_YL);
	if(!TXT_MODE){
		for(i=0; i<l; i++){
			(*d0)=(*src++); d0+=VRAM_STP;
			(*d1)=(*src++); d1+=VRAM_STP;
		}
	} else {
		for(i=0; i<l; i++){
			(*d0)=(*src); d0+=VRAM_STP;
			(*d1)=(*src); d1+=VRAM_STP; src++;
			(*d0)=(*src); d0+=VRAM_STP;
			(*d1)=(*src); d1+=VRAM_STP; src++;
		}
	}
}

void _xor_sub(byte *src,byte *d0,byte *d1)
{
	byte i,l,c;

	l=(FNT_YL>8?8:FNT_YL);
	if(!TXT_MODE){
		for(i=0; i<l; i++){
			(*d0)=~(*src++); d0+=VRAM_STP;
			(*d1)=~(*src++); d1+=VRAM_STP;
		}
	} else {
		for(i=0; i<l; i++){
			c=~(*src++);
			(*d0)=c; d0+=VRAM_STP;
			(*d1)=c; d1+=VRAM_STP;
			c=~(*src++);
			(*d0)=c; d0+=VRAM_STP;
			(*d1)=c; d1+=VRAM_STP;
		}
	}
}

//......................................................................

// Hx1 Vx1
void ptn_put0(word adr,byte atr,struct GPTN *ptn)
{
	byte *db0,*dr0,*dg0,*dm0;
	byte *db1,*dr1,*dg1,*dm1;
	byte *sb,*sr,*sg;
	word n;

	n=adr+((FNT_YL-1)*VRAM_STP);
	if(n>=0x4000) return;

	_flg_sub(&CRT_F00[adr]);
	_flg_sub(&CRT_F01[adr]);

	sb=(ptn->b); sr=(ptn->r); sg=(ptn->g);
	db0=&TXT_B00[adr]; dr0=&TXT_R00[adr];
	dg0=&TXT_G00[adr]; dm0=&TXT_M00[adr];
	db1=&TXT_B01[adr]; dr1=&TXT_R01[adr];
	dg1=&TXT_G01[adr]; dm1=&TXT_M01[adr];

	_clr_sub(dm0); _clr_sub(dm1);
	if(atr&0x18){
		if(atr&1){ _xor_sub(sb,db0,db1); _msk_sub(db0,dm0); _msk_sub(db1,dm1); }
		else{ _clr_sub(db0); _clr_sub(db1); }
		if(atr&2){ _xor_sub(sr,dr0,dr1); _msk_sub(dr0,dm0); _msk_sub(dr1,dm1); }
		else{ _clr_sub(dr0); _clr_sub(dr1); }
		if(atr&4){ _xor_sub(sg,dg0,dg1); _msk_sub(dg0,dm0); _msk_sub(dg1,dm1); }
		else{ _clr_sub(dg0); _clr_sub(dg1); }
	} else {
		if(atr&1){ _cpy_sub(sb,db0,db1); _msk_sub(db0,dm0); _msk_sub(db1,dm1); }
		else{ _clr_sub(db0); _clr_sub(db1); }
		if(atr&2){ _cpy_sub(sr,dr0,dr1); _msk_sub(dr0,dm0); _msk_sub(dr1,dm1); }
		else{ _clr_sub(dr0); _clr_sub(dr1); }
		if(atr&4){ _cpy_sub(sg,dg0,dg1); _msk_sub(dg0,dm0); _msk_sub(dg1,dm1); }
		else{ _clr_sub(dg0); _clr_sub(dg1); }
	}
}

// Hx1 Vx2
void ptn_put1(word adr,byte atr,struct GPTN *ptn)
{
	static byte tb[16],tr[16],tg[16];
	byte *src,*des;
	word i,off;

	i=(adr-VRAM_TOP)/TXT_XL;
	off=(i&1)?8:0;

	src=&ptn->b[off]; des=tb;
	for(i=0; i<8; i++){ (*des++)=(*src); (*des++)=(*src++); }
	src=&ptn->r[off]; des=tr;
	for(i=0; i<8; i++){ (*des++)=(*src); (*des++)=(*src++); }
	src=&ptn->g[off]; des=tg;
	for(i=0; i<8; i++){ (*des++)=(*src); (*des++)=(*src++); }

	(ptn->b)=tb; (ptn->r)=tr; (ptn->g)=tg;
	ptn_put0(adr,atr,ptn);
}

// Hx2 Vx1
void ptn_put2(word adr,byte atr,struct GPTN *ptn,word rl)
{
	static byte tb[16],tr[16],tg[16];
	byte *src,*des,*tbl;
	word i;

	tbl=(rl?X2TBL1:X2TBL0);
	src=(ptn->b); des=tb; for(i=0; i<16; i++) des[i]=tbl[src[i]];
	src=(ptn->r); des=tr; for(i=0; i<16; i++) des[i]=tbl[src[i]];
	src=(ptn->g); des=tg; for(i=0; i<16; i++) des[i]=tbl[src[i]];

	(ptn->b)=tb; (ptn->r)=tr; (ptn->g)=tg;
	ptn_put0(adr,atr,ptn);
}

// Hx2 Vx2
void ptn_put3(word adr,byte atr,struct GPTN *ptn,word rl)
{
	static byte tb[16],tr[16],tg[16];
	byte *src,*des,*tbl;
	word i,off;
	byte tmp,dmy;

	tbl=(rl?X2TBL1:X2TBL0);

	i=(adr-VRAM_TOP)/TXT_XL;
	off=(i&1)?8:0;

	src=&ptn->b[off]; des=tb;
	for(i=0; i<8; i++){ tmp=tbl[src[i]]; (*des++)=tmp; (*des++)=tmp; }
	src=&ptn->r[off]; des=tr;
	for(i=0; i<8; i++){ tmp=tbl[src[i]]; (*des++)=tmp; (*des++)=tmp; }
	src=&ptn->g[off]; des=tg;
	for(i=0; i<8; i++){ tmp=tbl[src[i]]; (*des++)=tmp; (*des++)=tmp; }

	(ptn->b)=tb; (ptn->r)=tr; (ptn->g)=tg;
	ptn_put0(adr,atr,ptn);
}

//----------------------------------------------------------------------

short hx2_rl(word adr)
{
	byte atr0,ank0,knj0;
	byte atr1,ank1,knj1;
	word top;

	if(adr<=VRAM_TOP) return 0;
	top=(adr-VRAM_TOP);
	top=(top/TXT_XL)*TXT_XL;
	if(top==adr) return 0;

	atr0=ank0=knj0=0;
	for(; top<adr; top++){
		atr1=TXT_ATR[top];
		ank1=TXT_ANK[top];
		knj1=TXT_KAN[top];
		if(!(atr1&0x80)) atr0=ank0=knj0=0;
		else if(ank0!=ank1){ atr0=atr1; ank0=ank1; knj0=knj1; }
		else if(atr0!=atr1){ atr0=atr1; ank0=ank1; knj0=knj1; }
		else if(knj0!=knj1){ atr0=atr1; ank0=ank1; knj0=knj1; }
		else atr0=ank0=knj0=0;
	}
	if(!atr0) return 0;

	if(ank1==TXT_ANK[adr]){
		if(atr0==TXT_ATR[adr]){
			if(knj1==TXT_KAN[adr]) return 1;
		}
	}

	return 0;
}

void txt_update_98(word adr)
{
	static byte *tvr=(byte *)0xa0000l;
	static byte *avr=(byte *)0xa2000l;
	word x,y,n;
	word off,jis;
	word knj,ank,atr;
	byte jh,jl;

	if(adr>=0x800) return;

	n=(adr-VRAM_TOP);
	y=(n/TXT_XL); if(FNT_YL>8) y*=2;
	x=(n%TXT_XL); if(CRT_H320) x*=2;
	if(x>=80 || y>=25) return;
	off=((y*80)+x)*2;

	atr=(word)TXT_ATR[adr];
	knj=(word)TXT_KAN[adr];
	ank=(word)TXT_ANK[adr];

	avr[off]=TXT_ATR98[atr&0x1f];
	if(atr & 0x20){
		tvr[off]=ank; tvr[off+1]=0;
	} else if(knj & 0x80){
		jis=adr2jis_x1t((knj<<8)|ank);
		jh=(jis>>8); jl=(jis&255);
		tvr[off]=jh-0x20;
		if(knj & 0x40) tvr[off+1]=(jl&0x7f);
		else           tvr[off+1]=(jl|0x80);
	} else {
		tvr[off]=ank; tvr[off+1]=0;
	}
}

void txt_update(word adr)
{
	static byte gai_b[16],gai_r[16],gai_g[16];
	static byte pcg_b[16],pcg_r[16],pcg_g[16];
	static byte knj_l[16],knj_r[16],ank_l[16];
	static word _gai=0xffff;
	static word _pcg=0xffff;
	static word _knj=0xffff;
	static word _ank=0xffff;
	byte *src,*des;
	struct GPTN ptn;
	word atr,ank,knj;
	word i,sw,rl;

	if(PC98FLG==2){ txt_update_98(adr); return; }

	if(adr>=0x800) return;

	atr=(word)(TXT_ATR[adr]);
	ank=(word)(TXT_ANK[adr]);
	knj=(word)(TXT_KAN[adr]);

	if(atr & 0x20){
		if(knj & 0x90){ // obfO
			i=(ank&0xfe);
			if(_gai!=i){
				_gai=i;
				des=gai_b;
				src=PCG_B[_gai  ]; for(i=0; i<8; i++) (*des++)=(*src++);
				src=PCG_B[_gai+1]; for(i=0; i<8; i++) (*des++)=(*src++);
				des=gai_r;
				src=PCG_R[_gai  ]; for(i=0; i<8; i++) (*des++)=(*src++);
				src=PCG_R[_gai+1]; for(i=0; i<8; i++) (*des++)=(*src++);
				des=gai_g;
				src=PCG_G[_gai  ]; for(i=0; i<8; i++) (*des++)=(*src++);
				src=PCG_G[_gai+1]; for(i=0; i<8; i++) (*des++)=(*src++);
			}
			ptn.b=gai_b; ptn.r=gai_r; ptn.g=gai_g;
		} else { // obfLN^
			if(_pcg!=ank){
				_pcg=ank;
				des=pcg_b; src=PCG_B[_pcg];
				for(i=0; i<8; i++){ (*des++)=(*src); (*des++)=(*src++); }
				des=pcg_r; src=PCG_R[_pcg];
				for(i=0; i<8; i++){ (*des++)=(*src); (*des++)=(*src++); }
				des=pcg_g; src=PCG_G[_pcg];
				for(i=0; i<8; i++){ (*des++)=(*src); (*des++)=(*src++); }
			}
			ptn.b=pcg_b; ptn.r=pcg_r; ptn.g=pcg_g;
		}
	} else if(knj & 0x80){
		i=(knj<<8)|ank;
		if(_knj!=i){ _knj=i; knj_ptn(adr2jis_x1t(_knj),knj_l,knj_r); }
		if(knj & 0x40) ptn.b=ptn.r=ptn.g=knj_r;
		else           ptn.b=ptn.r=ptn.g=knj_l;
	} else if(CRT_V400!=0 && !TXT_MODE){
		ptn.b=ptn.r=ptn.g=&KNJ_FNT[ank*16];
	} else {
		if(_ank!=ank){
			_ank=ank;
			des=ank_l; src=ANK_FNT[_ank];
			for(i=0; i<8; i++){ (*des++)=(*src); (*des++)=(*src++); }
		}
		ptn.b=ptn.r=ptn.g=ank_l;
	}

	sw=(atr>>6)&3; rl=0;
	if(sw>1 && adr) rl=hx2_rl(adr);

	switch(sw){
		case 0: ptn_put0(adr,atr,&ptn); break; // Hx1 Vx1
		case 1: ptn_put1(adr,atr,&ptn); break; // Hx1 Vx2
		case 2: ptn_put2(adr,atr,&ptn,rl); break; // Hx2 Vx1
		case 3: ptn_put3(adr,atr,&ptn,rl); break; // Hx2 Vx2
	}
}

/***********************************************************************
	eLXg u|q`l
***********************************************************************/

void x1_txt_w(word Port,byte Value)
{
	byte *vrm;

	if(     Port>=0x3800){ Port-=0x3800; vrm=&TXT_KAN[Port]; }
	else if(Port>=0x3000){ Port-=0x3000; vrm=&TXT_ANK[Port]; }
	else if(Port>=0x2800){ Port-=0x2800; vrm=&TXT_ATR[Port]; }
	else if(Port>=0x2000){ Port-=0x2000; vrm=&TXT_ATR[Port]; }

	if((*vrm)==Value) return;

	(*vrm)=Value;

	txt_update(Port);
	if(TXT_ATR[Port]&0x80){
		if(Port      ) txt_update(Port-1);
		if(Port<0x7ff) txt_update(Port+1);
	}
}

byte x1_txt_r(word Port)
{
	if(Port>=0x3800) return TXT_KAN[Port-0x3800];
	if(Port>=0x3000) return TXT_ANK[Port-0x3000];
	if(Port>=0x2800) return TXT_ATR[Port-0x2800];
	if(Port>=0x2000) return TXT_ATR[Port-0x2000];
	return 0xff;
}

/***********************************************************************
	OtBbN u|q`l
***********************************************************************/

void grp_w(word col,word adr,byte val)
{
	byte *vrm;
	short sw;

	sw=0;
	if(!CPU_BANK){
		if(col & 1){ vrm=&GRP_B00[adr]; if(*vrm!=val){ *vrm=val; sw=1; } }
		if(col & 2){ vrm=&GRP_R00[adr]; if(*vrm!=val){ *vrm=val; sw=1; } }
		if(col & 4){ vrm=&GRP_G00[adr]; if(*vrm!=val){ *vrm=val; sw=1; } }
		if(sw) CRT_F00[adr]|=2;
	} else {
		if(col & 1){ vrm=&GRP_B01[adr]; if(*vrm!=val){ *vrm=val; sw=1; } }
		if(col & 2){ vrm=&GRP_R01[adr]; if(*vrm!=val){ *vrm=val; sw=1; } }
		if(col & 4){ vrm=&GRP_G01[adr]; if(*vrm!=val){ *vrm=val; sw=1; } }
		if(sw) CRT_F01[adr]|=2;
	}
}

void x1_grp_w2(word Port,byte Value)
{
	word hi;
	hi=(Port>>8);
	if(     hi>=0xc0) grp_w(3,Port-0xc000,Value);
	else if(hi>=0x80) grp_w(5,Port-0x8000,Value);
	else if(hi>=0x40) grp_w(6,Port-0x4000,Value);
	else              grp_w(7,Port       ,Value);
}

void x1_grp_w(word Port,byte Value)
{
	word hi;
	hi=(Port>>8);
	if(     hi>=0xc0) grp_w(4,Port-0xc000,Value);
	else if(hi>=0x80) grp_w(2,Port-0x8000,Value);
	else if(hi>=0x40) grp_w(1,Port-0x4000,Value);
}

byte x1_grp_r(word Port)
{
	word hi;
	hi=(Port>>8);
	if(!CPU_BANK){
		if(     hi>=0xc0) return GRP_G00[Port-0xc000];
		else if(hi>=0x80) return GRP_R00[Port-0x8000];
		else if(hi>=0x40) return GRP_B00[Port-0x4000];
	} else {
		if(     hi>=0xc0) return GRP_G01[Port-0xc000];
		else if(hi>=0x80) return GRP_R01[Port-0x8000];
		else if(hi>=0x40) return GRP_B01[Port-0x4000];
	}
	return 0xff;
}

/***********************************************************************
	PC̕\pf[^쐬
***********************************************************************/

short flgs_chk(unsigned long ptn,word bnk,word y)
{
	unsigned long *lw;
	word i;

	i=VTOP_TBL[y];
	if(!bnk) lw=(unsigned long *)&CRT_F00[i];
	else     lw=(unsigned long *)&CRT_F01[i];

	i=(TXT_XL/4);
	while(i--){
		if(*lw & ptn) return 1;
		lw++;
	}

	return 0;
}

void flgs_set(unsigned long ptn,word bnk,word y)
{
	unsigned long *lw;
	word i;

	i=VTOP_TBL[y];
	if(!bnk) lw=(unsigned long *)&CRT_F00[i];
	else     lw=(unsigned long *)&CRT_F01[i];

	i=(TXT_XL/4);
	while(i--) (*lw++)|=ptn;
}

void flgs_clr(unsigned long ptn,word bnk,word y)
{
	unsigned long *lw;
	word i;

	i=VTOP_TBL[y];
	if(!bnk) lw=(unsigned long *)&CRT_F00[i];
	else     lw=(unsigned long *)&CRT_F01[i];

	i=(TXT_XL/4);
	while(i--) (*lw++)&=ptn;
}

void gmsk_make(byte *flgs,struct GPTN *ptn)
{
	byte *bb,*rr,*gg,*mm;
	byte b,r,g,m,c,bit;
	word x;

	bb=(ptn->b); rr=(ptn->r);
	gg=(ptn->g); mm=(ptn->m);

	if(CRT_PLY==0xff){
		for(x=0; x<TXT_XL; x++){
			mm[x]=0xff; if(flgs[x] & 2) flgs[x]=1;
		}
		return;
	}

	if(CRT_PLY==0x00){
		for(x=0; x<TXT_XL; x++){
			mm[x]=0x00; if(flgs[x] & 2) flgs[x]=1;
		}
		return;
	}

	for(x=0; x<TXT_XL; x++){
		if(flgs[x] & 2){
			b=bb[x]; r=rr[x]; g=gg[x]; m=0;
			for(bit=0x80; bit; bit>>=1){
				c=1;
				if(b & bit) c<<=1;
				if(r & bit) c<<=2;
				if(g & bit) c<<=4;
				if(CRT_PLY & c) m|=bit;
			}
			mm[x]=m;
			flgs[x]=1;
		}
	}
}

//----------------------------------------------------------------------

short ptn_make_98(short g_bnk,short t_bnk,word y,struct GPTN *ptn)
{
	word off,ans;

	off=VTOP_TBL[y];
	if(off+TXT_XL>0x4000) return 0;

	if(g_bnk){
		ptn->b=&GRP_B01[off]; ptn->r=&GRP_R01[off];
		ptn->g=&GRP_G01[off]; ptn->m=DMY_00;
	} else {
		ptn->b=&GRP_B00[off]; ptn->r=&GRP_R00[off];
		ptn->g=&GRP_G00[off]; ptn->m=DMY_00;
	}

	ans=flgs_chk(0x03030303l,g_bnk,y);
	flgs_clr(0x0l,g_bnk,y);

	if(!CRT_UPDT && !ans) return 0;
	return 1;
}

short ptn_make(short g_bnk,short t_bnk,word y,struct GPTN *ptn)
{
	byte *t_flg;
	byte *g_flg;
	struct GPTN grp,txt,crt;
	word i,x,off;
	byte tmsk,gmsk;

	if(PC98FLG==2){
		return ptn_make_98(g_bnk,t_bnk,y,ptn);
	}

	off=VTOP_TBL[y];
	if(off+TXT_XL>0x4000) return 0;

	if(!CRT_UPDT){
		if(!flgs_chk(0x03030303l,g_bnk,y)){
			if(!flgs_chk(0x01010101l,t_bnk,y)) return 0;
		}
	}

	if(!t_bnk){
		t_flg=&CRT_F00[off];
		txt.b=&TXT_B00[off]; txt.r=&TXT_R00[off];
		txt.g=&TXT_G00[off]; txt.m=&TXT_M00[off];
	} else {
		t_flg=&CRT_F01[off];
		txt.b=&TXT_B01[off]; txt.r=&TXT_R01[off];
		txt.g=&TXT_G01[off]; txt.m=&TXT_M01[off];
	}
	if(!g_bnk){
		g_flg=&CRT_F00[off];
		grp.b=&GRP_B00[off]; grp.r=&GRP_R00[off];
		grp.g=&GRP_G00[off]; grp.m=&GRP_M00[off];
		if(!t_bnk){
			crt.b=&CRT_B00[off]; crt.r=&CRT_R00[off];
			crt.g=&CRT_G00[off]; crt.m=&CRT_M00[off];
		} else {
			crt.b=&CRT_B01[off]; crt.r=&CRT_R01[off];
			crt.g=&CRT_G01[off]; crt.m=&CRT_M01[off];
		}
	} else {
		g_flg=&CRT_F01[off];
		grp.b=&GRP_B01[off]; grp.r=&GRP_R01[off];
		grp.g=&GRP_G01[off]; grp.m=&GRP_M01[off];
		if(!t_bnk){
			crt.b=&CRT_B02[off]; crt.r=&CRT_R02[off];
			crt.g=&CRT_G02[off]; crt.m=&CRT_M02[off];
		} else {
			crt.b=&CRT_B03[off]; crt.r=&CRT_R03[off];
			crt.g=&CRT_G03[off]; crt.m=&CRT_M03[off];
		}
	}
	(*ptn)=crt;

	if(flgs_chk(0x02020202l,g_bnk,y)) gmsk_make(g_flg,&grp);

	if(       CRT_PLY==0xff){
		memcpy(crt.b,grp.b,TXT_XL); memcpy(crt.r,grp.r,TXT_XL);
		memcpy(crt.g,grp.g,TXT_XL); memset(crt.m,    0,TXT_XL);
		return 1;
	}
	if(CRT_PLY==0x00){
		for(x=0; x<TXT_XL; x++){
			if(t_flg[x] || g_flg[x] || CRT_UPDT){
				gmsk=~txt.m[x];
				crt.b[x]=txt.b[x]|(grp.b[x]&gmsk);
				crt.r[x]=txt.r[x]|(grp.r[x]&gmsk);
				crt.g[x]=txt.g[x]|(grp.g[x]&gmsk);
				crt.m[x]=txt.m[x];
			}
		}
		return 1;
	}

	for(x=0; x<TXT_XL; x++){
		if(t_flg[x] || g_flg[x] || CRT_UPDT){
			if(       !txt.m[x]){
				crt.b[x]=grp.b[x]; crt.r[x]=grp.r[x];
				crt.g[x]=grp.g[x]; crt.m[x]=0;
			} else if(!grp.m[x]){
				crt.b[x]=txt.b[x]; crt.r[x]=txt.r[x];
				crt.g[x]=txt.g[x]; crt.m[x]=0xff;
			} else {
				tmsk=txt.m[x]; tmsk&=~grp.m[x]; gmsk=~tmsk;
				crt.b[x]=(txt.b[x]&tmsk)|(grp.b[x]&gmsk);
				crt.r[x]=(txt.r[x]&tmsk)|(grp.r[x]&gmsk);
				crt.g[x]=(txt.g[x]&tmsk)|(grp.g[x]&gmsk);
				crt.m[x]=tmsk;
			}
		}
	}

	return 1;
}

/***********************************************************************
	PC\
***********************************************************************/

void ptn_disp(short y,struct GPTN *ptn)
{
	word tmp_b[48],tmp_r[48];
	word tmp_g[48],tmp_m[48];
	struct GPTN p;
	word x1,x2,xl,i;

	p=(*ptn);

	// SO[hȂ牡Ɋg
	if(CRT_H320){
		xl=TXT_XL; if(xl>40) xl=40;
		for(i=0; i<xl; i++){
			tmp_b[i]=X2TBLW[p.b[i]]; tmp_r[i]=X2TBLW[p.r[i]];
			tmp_g[i]=X2TBLW[p.g[i]]; tmp_m[i]=X2TBLW[p.m[i]];
		}
		p.b=(byte *)tmp_b; p.r=(byte *)tmp_r;
		p.g=(byte *)tmp_g; p.m=(byte *)tmp_m;
	}

	// GMASK ... Rg̕\̍XV֎~GA
	if(!GMASK_FLG[y]){ put_line(0,y,80,&p); return; }

	x1=x2=xl=0;
	for(;;){
		x1=x2; xl=0;
		while( GMASK_MSK[y][x1] && x1<80){ x1++; xl++; }
		if(x1>=80) break;
		if(xl){ p.b+=xl; p.r+=xl; p.g+=xl; p.m+=xl; }

		x2=x1; xl=0;
		while(!GMASK_MSK[y][x2] && x2<80){ x2++; xl++; }
		if(xl){ put_line(x1,y,xl,&p); p.b+=xl; p.r+=xl; p.g+=xl; p.m+=xl; }
		if(x2>=80) break;
	}
}

void disp_line(short y)
{
	struct GPTN ptn;

	if(y>=200 || y>=CRT_YL) return;

	if(      CRT_V400==0){
		if(ptn_make(CRT_BANK,0,y,&ptn)){
			ptn_disp((y*2),&ptn);
			if(CRT_MODE) ptn_disp((y*2)+1,&ptn);
			flgs_clr(0xfefefefel,0,y);
			if(CRT_BANK) flgs_clr(0xfefefefel,1,y);
		}
	}else if(CRT_V400==1){
		if(ptn_make(0,0,y,&ptn)) ptn_disp((y*2)  ,&ptn);
		if(ptn_make(1,1,y,&ptn)) ptn_disp((y*2)+1,&ptn);
		flgs_clr(0xfefefefel,0,y); flgs_clr(0xfefefefel,1,y);
	}else if(CRT_V400==3){
		if(ptn_make(CRT_BANK,0,y,&ptn)) ptn_disp((y*2)  ,&ptn);
		if(ptn_make(CRT_BANK,1,y,&ptn)) ptn_disp((y*2)+1,&ptn);
		flgs_clr(0xfefefefel,0,y); flgs_clr(0xfefefefel,1,y);
	}
}

/***********************************************************************
	ĕ`
***********************************************************************/

void text_redraw(void)
{
	unsigned char *vrm;
	word i;

	if(PC98FLG){
		vrm=(unsigned char *)0xa0000l;
		memset(vrm,0x20,0x2000);
		vrm=(unsigned char *)0xa2000l;
		for(i=0; i<0x2000; i+=2) vrm[i]=0xe1;
	}

	for(i=0; i<0x800; i++) txt_update(i);
}

void vram_redraw(void)
{
	memset(CRT_F00,3,0x4000);
	memset(CRT_F01,3,0x4000);
}

void scrn_update(short sw)
{
	struct GPTN crt;
	word y;

	if(sw && PC98FLG==2) PC98FLG=1;
	else sw=0;

	text_redraw();
	vram_redraw();

	CRT_UPDT=1;
	for(y=0; y<200; y++) disp_line(y);
	CRT_UPDT=0;

	if(CRT_V400==0 && !CRT_MODE){
		crt.b=DMY_00; crt.r=DMY_00;
		crt.g=DMY_00; crt.m=DMY_00;
		for(y=0; y<400; y+=2) put_line(0,y+1,80,&crt);
	}

	if(sw) PC98FLG=2;
}

